#line 1 "regcomp.c"
#ifdef PERL_EXT_RE_BUILD
#  ifndef PERL_IN_XSUB_RE
#    define PERL_IN_XSUB_RE
#  endif
#  if defined(PERL_EXT_RE_DEBUG) && !defined(DEBUGGING)
#    define DEBUGGING
#  endif
#endif
#ifdef PERL_IN_XSUB_RE
#  define Perl_pregcomp my_regcomp
#  define Perl_regdump my_regdump
#  define Perl_regprop my_regprop
#  define Perl_pregfree my_regfree
#  define Perl_re_intuit_string my_re_intuit_string
#  define Perl_regnext my_regnext
#  define Perl_save_re_context my_save_re_context
#  define Perl_reginitcolors my_reginitcolors
#  define PERL_NO_GET_CONTEXT
#endif
#include "EXTERN.h"
#define PERL_IN_REGCOMP_C
#include "perl.h"
#ifndef PERL_IN_XSUB_RE
#  include "INTERN.h"
#endif
#define REG_COMP_C
#include "regcomp.h"
#ifdef op
#undef op
#endif 
#ifdef MSDOS
#  if defined(BUGGY_MSC6)
#    pragma optimize("a",off)
#    pragma optimize("w",on )
#  endif 
#endif 
#ifndef STATIC
#define	STATIC	static
#endif
#if ADD_TO_REGEXEC
#define RExC_starttry	(pRExC_state->starttry)
#endif
#define RExC_flags	(pRExC_state->flags)
#define RExC_precomp	(pRExC_state->precomp)
#define RExC_rx		(pRExC_state->rx)
#define RExC_start	(pRExC_state->start)
#define RExC_end	(pRExC_state->end)
#define RExC_parse	(pRExC_state->parse)
#define RExC_whilem_seen	(pRExC_state->whilem_seen)
#define RExC_offsets	(pRExC_state->rx->offsets) 
#define RExC_emit	(pRExC_state->emit)
#define RExC_emit_start	(pRExC_state->emit_start)
#define RExC_naughty	(pRExC_state->naughty)
#define RExC_sawback	(pRExC_state->sawback)
#define RExC_seen	(pRExC_state->seen)
#define RExC_size	(pRExC_state->size)
#define RExC_npar	(pRExC_state->npar)
#define RExC_extralen	(pRExC_state->extralen)
#define RExC_seen_zerolen	(pRExC_state->seen_zerolen)
#define RExC_seen_evals	(pRExC_state->seen_evals)
#define RExC_utf8	(pRExC_state->utf8)
#define	ISMULT1(c)	((c) == '*' || (c) == '+' || (c) == '?')
#define	ISMULT2(s)	((*s) == '*' || (*s) == '+' || (*s) == '?' || 
#ifdef SPSTART
#undef SPSTART		
#endif
#define	WORST		0	
#define	HASWIDTH	0x1	
#define	SIMPLE		0x2	
#define	SPSTART		0x4	
#define TRYAGAIN	0x8	
#define SF_BEFORE_EOL		(SF_BEFORE_SEOL|SF_BEFORE_MEOL)
#define SF_BEFORE_SEOL		0x1
#define SF_BEFORE_MEOL		0x2
#define SF_FIX_BEFORE_EOL	(SF_FIX_BEFORE_SEOL|SF_FIX_BEFORE_MEOL)
#define SF_FL_BEFORE_EOL	(SF_FL_BEFORE_SEOL|SF_FL_BEFORE_MEOL)
#ifdef NO_UNARY_PLUS
#  define SF_FIX_SHIFT_EOL	(0+2)
#  define SF_FL_SHIFT_EOL		(0+4)
#else
#  define SF_FIX_SHIFT_EOL	(+2)
#  define SF_FL_SHIFT_EOL		(+4)
#endif
#define SF_FIX_BEFORE_SEOL	(SF_BEFORE_SEOL << SF_FIX_SHIFT_EOL)
#define SF_FIX_BEFORE_MEOL	(SF_BEFORE_MEOL << SF_FIX_SHIFT_EOL)
#define SF_FL_BEFORE_SEOL	(SF_BEFORE_SEOL << SF_FL_SHIFT_EOL)
#define SF_FL_BEFORE_MEOL	(SF_BEFORE_MEOL << SF_FL_SHIFT_EOL) 
#define SF_IS_INF		0x40
#define SF_HAS_PAR		0x80
#define SF_IN_PAR		0x100
#define SF_HAS_EVAL		0x200
#define SCF_DO_SUBSTR		0x400
#define SCF_DO_STCLASS_AND	0x0800
#define SCF_DO_STCLASS_OR	0x1000
#define SCF_DO_STCLASS		(SCF_DO_STCLASS_AND|SCF_DO_STCLASS_OR)
#define SCF_WHILEM_VISITED_POS	0x2000
#define UTF (RExC_utf8 != 0)
#define LOC ((RExC_flags & PMf_LOCALE) != 0)
#define FOLD ((RExC_flags & PMf_FOLD) != 0)
#define OOB_UNICODE		12345678
#define OOB_NAMEDCLASS		-1
#define CHR_SVLEN(sv) (UTF ? sv_len_utf8(sv) : SvCUR(sv))
#define CHR_DIST(a,b) (UTF ? utf8_distance(a,b) : a - b)
#define RegexLengthToShowInErrorMessages 127
#define MARKER1 "<-- HERE"    
#define MARKER2 " <-- HERE "  
#define REPORT_LOCATION " in regex; marked by " MARKER1 " in m/%.*s" MARKER2 "%s/"
#define	FAIL(msg) STMT_START {						
#define	FAIL2(pat,msg) STMT_START {					
#define	Simple_vFAIL(m) STMT_START {					
#define	vFAIL(m) STMT_START {				
#define	Simple_vFAIL2(m,a1) STMT_START {			
#define	vFAIL2(m,a1) STMT_START {			
#define	Simple_vFAIL3(m, a1, a2) STMT_START {			
#define	vFAIL3(m,a1,a2) STMT_START {			
#define	Simple_vFAIL4(m, a1, a2, a3) STMT_START {		
#define	Simple_vFAIL5(m, a1, a2, a3, a4) STMT_START {		
#define	vWARN(loc,m) STMT_START {					
#define	vWARNdep(loc,m) STMT_START {					
#define	vWARN2(loc, m, a1) STMT_START {					
#define	vWARN3(loc, m, a1, a2) STMT_START {				
#define	vWARN4(loc, m, a1, a2, a3) STMT_START {				
#define	vWARN5(loc, m, a1, a2, a3, a4) STMT_START {			
#define REGC(c,s) STMT_START {			
#define MJD_OFFSET_DEBUG(x)
#define Set_Node_Offset_To_R(node,byte) STMT_START {			
#define Set_Node_Offset(node,byte) 
#define Set_Cur_Node_Offset Set_Node_Offset(RExC_emit, RExC_parse)
#define Set_Node_Length_To_R(node,len) STMT_START {			
#define Set_Node_Length(node,len) 
#define Set_Cur_Node_Length(len) Set_Node_Length(RExC_emit, len)
#define Set_Node_Cur_Length(node) 
#define Node_Offset(n) (RExC_offsets[2*((n)-RExC_emit_start)-1])
#define Node_Length(n) (RExC_offsets[2*((n)-RExC_emit_start)])
#if defined(__sparc64__) && defined(__GNUC__)
#   if __GNUC__ < 2 || (__GNUC__ == 2 && __GNUC_MINOR__ < 96)
#       undef  SPARC64_GCC_WORKAROUND
#       define SPARC64_GCC_WORKAROUND 1
#   endif
#endif
#ifdef DEBUGGING
#endif
#ifdef DEBUGGING
#endif
#ifdef DEBUGGING
#endif
#ifdef DEBUGGING
#endif
#ifdef DEBUGGING
#endif
#ifdef DEBUGGING
#endif
#ifdef DEBUGGING
#endif
#ifdef DEBUGGING
#endif
#if 0
#endif
#if defined(SPARC64_GCC_WORKAROUND)
#else
#endif
#if 0 
#endif
#ifdef DEBUGGING
#endif
#if 0				
#endif
#define POSIXCC_DONE(c)   ((c) == ':')
#define POSIXCC_NOTYET(c) ((c) == '=' || (c) == '.')
#define POSIXCC(c) (POSIXCC_DONE(c) || POSIXCC_NOTYET(c))
#ifdef EBCDIC
#endif
#ifdef EBCDIC
#endif
#ifndef EBCDIC
#else  
#endif 
#ifndef EBCDIC
#else  
#endif 
#ifdef EBCDIC
#endif
#ifdef EBCDIC
#endif
#ifdef DEBUGGING
#endif	
#ifdef DEBUGGING
#endif	
#ifdef DEBUGGING
#endif	
#ifdef DEBUGGING
#endif	
#ifdef DEBUGGING
#endif
#ifdef I_STDARG
#else
#endif
#ifdef DEBUGGING
#endif
