#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "test.h"

#define PERL_constant_NOTFOUND	1
#define PERL_constant_NOTDEF	2
#define PERL_constant_ISIV	3
#define PERL_constant_ISNO	4
#define PERL_constant_ISNV	5
#define PERL_constant_ISPV	6
#define PERL_constant_ISPVN	7
#define PERL_constant_ISSV	8
#define PERL_constant_ISUNDEF	9
#define PERL_constant_ISUV	10
#define PERL_constant_ISYES	11

#ifndef NVTYPE
typedef double NV; /* 5.6 and later define NVTYPE, and typedef NV to it.  */
#endif
#ifndef aTHX_
#define aTHX_ /* 5.6 or later define this for threading support.  */
#endif
#ifndef pTHX_
#define pTHX_ /* 5.6 or later define this for threading support.  */
#endif
static int
constant_1 (pTHX_ const char *name, int utf8, IV *iv_return, const char **pv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     E N S W "\x{A3}" */
  /* Offset 0 gives the best switch position.  */
  switch (name[0]) {
  case 'E':
    {
#ifdef E
      *iv_return = E;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'N':
    {
#ifdef N
      *iv_return = N;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'S':
    {
#ifdef S
      *iv_return = S;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'W':
    {
#ifdef W
      *iv_return = W;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case '\243':
    {
      if (!utf8) {
        *pv_return = "Sterling";
        return PERL_constant_ISPV;
      }
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant_2 (pTHX_ const char *name, int utf8, IV *iv_return, const char **pv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     "*"."/" "/"."*" NE NW No SE SW "\x{C2}\x{A3}" */
  /* Offset 1 gives the best switch position.  */
  switch (name[1]) {
  case '*':
    if (name[0] == '/') {
      *pv_return = "OPEN";
      return PERL_constant_ISPV;
    }
    break;
  case '/':
    if (name[0] == '*') {
      *pv_return = "CLOSE";
      return PERL_constant_ISPV;
    }
    break;
  case 'E':
    if (name[0] == 'N') {
#ifdef NE
      *iv_return = NE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    if (name[0] == 'S') {
#ifdef SE
      *iv_return = SE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'W':
    if (name[0] == 'N') {
#ifdef NW
      *iv_return = NW;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    if (name[0] == 'S') {
#ifdef SW
      *iv_return = SW;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'o':
    if (name[0] == 'N') {
#ifdef No
      return PERL_constant_ISNO;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case '\243':
    if (name[0] == '\302') {
      if (utf8) {
        *pv_return = "Sterling";
        return PERL_constant_ISPV;
      }
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant_3 (pTHX_ const char *name, IV *iv_return, const char **pv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     OK6 OK7 Yes */
  /* Offset 2 gives the best switch position.  */
  switch (name[2]) {
  case '6':
    if (name[0] == 'O' && name[1] == 'K') {
#ifdef OK6
      *pv_return = OK6;
      return PERL_constant_ISPV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case '7':
    if (name[0] == 'O' && name[1] == 'K') {
#ifdef OK7
      *pv_return = "not ok 7\n\0ok 7\n";
      *iv_return = (IV) 15;
      return PERL_constant_ISPVN;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 's':
    if (name[0] == 'Y' && name[1] == 'e') {
#ifdef Yes
      return PERL_constant_ISYES;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant_4 (pTHX_ const char *name, IV *iv_return, const char **pv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     FIVE OPEN perl */
  /* Offset 1 gives the best switch position.  */
  switch (name[1]) {
  case 'I':
    if (memEQ(name, "FIVE", 4)) {
    /*                ^        */
#ifdef FIVE
      *iv_return = FIVE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'P':
    if (memEQ(name, "OPEN", 4)) {
    /*                ^        */
      *pv_return = "/*";
      return PERL_constant_ISPV;
    }
    break;
  case 'e':
    if (memEQ(name, "perl", 4)) {
    /*                ^        */
#ifdef perl
      *pv_return = perl;
      return PERL_constant_ISPV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant (pTHX_ const char *name, STRLEN len, int utf8, IV *iv_return, NV *nv_return, const char **pv_return, SV **sv_return) {
  /* Initially switch on the length of the name.  */
  /* When generated this function returned values for the list of names given
     in this section of perl code.  Rather than manually editing these functions
     to add or remove constants, which would result in this comment and section
     of code becoming inaccurate, we recommend that you edit this section of
     code, and use it to regenerate a new set of constant functions which you
     then use to replace the originals.

     Regenerate these constant functions by feeding this entire source file to
     perl -x

#!/work/armbe/spam_util/perl-5.8.3/perl -w
use ExtUtils::Constant qw (constant_types C_constant XS_constant);

my $types = {map {($_, 1)} qw( IV NO NV PV PVN SV UNDEF UV YES)};
my @names = (qw(E FIVE N NE NOTDEF NW S SE SW W),
            {name=>"*" . "/", type=>"PV", macro=>"1", value=>"\"CLOSE\""},
            {name=>"/" . "*", type=>"PV", macro=>"1", value=>"\"OPEN\""},
            {name=>"ANSWER", type=>"IV", default=>["UV", "42"]},
            {name=>"CLOSE", type=>"PV", macro=>["#if 1\n", "#endif\n"], value=>"\"*" . "/\""},
            {name=>"FARTHING", type=>"NV"},
            {name=>"NOT_ZERO", type=>"UV", value=>"~(UV)0"},
            {name=>"No", type=>"NO"},
            {name=>"OK6", type=>"PV"},
            {name=>"OK7", type=>"PVN", value=>["\"not ok 7\\n\\0ok 7\\n\"", "15"]},
            {name=>"OPEN", type=>"PV", macro=>"1", value=>"\"/" . "*\""},
            {name=>"RFC1149", type=>"SV", value=>"sv_2mortal(temp_sv)", pre=>"SV *temp_sv = newSVpv(RFC1149, 0); (void) SvUPGRADE(temp_sv,SVt_PVIV); SvIOK_on(temp_sv); SvIVX(temp_sv) = 1149;"},
            {name=>"Undef", type=>"UNDEF"},
            {name=>"Yes", type=>"YES"},
            {name=>"perl", type=>"PV"},
            {name=>"\x{A3}", type=>"PV", macro=>"1", value=>"\"Sterling\""});

print constant_types(); # macro defs
foreach (C_constant ("ExtTest", 'constant', 'IV', $types, undef, 3, @names) ) {
    print $_, "\n"; # C constant subs
}
print "#### XS Section:\n";
print XS_constant ("ExtTest", $types);
__END__
   */

  switch (len) {
  case 1:
    return constant_1 (aTHX_ name, utf8, iv_return, pv_return);
    break;
  case 2:
    return constant_2 (aTHX_ name, utf8, iv_return, pv_return);
    break;
  case 3:
    return constant_3 (aTHX_ name, iv_return, pv_return);
    break;
  case 4:
    return constant_4 (aTHX_ name, iv_return, pv_return);
    break;
  case 5:
    /* Names all of length 5.  */
    /* CLOSE Undef */
    /* Offset 0 gives the best switch position.  */
    switch (*name++) {
    case 'C':
      if (memEQ(name, "LOSE", 4)) {
      /*              C          */
#if 1
        *pv_return = "*/";
        return PERL_constant_ISPV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'U':
      if (memEQ(name, "ndef", 4)) {
      /*              U          */
#ifdef Undef
        return PERL_constant_ISUNDEF;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 6:
    /* Names all of length 6.  */
    /* ANSWER NOTDEF */
    /* Offset 1 gives the best switch position.  */
    switch (name[1]) {
    case 'N':
      if (memEQ(name, "ANSWER", 6)) {
      /*                ^          */
#ifdef ANSWER
        *iv_return = ANSWER;
        return PERL_constant_ISIV;
#else
        *iv_return = (IV) 42;
        return PERL_constant_ISUV;
#endif
      }
      break;
    case 'O':
      if (memEQ(name, "NOTDEF", 6)) {
      /*                ^          */
#ifdef NOTDEF
        *iv_return = NOTDEF;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 7:
    if (memEQ(name, "RFC1149", 7)) {
#ifdef RFC1149
      {
SV *temp_sv = newSVpv(RFC1149, 0); (void) SvUPGRADE(temp_sv,SVt_PVIV); SvIOK_on(temp_sv); SvIVX(temp_sv) = 1149;
        *sv_return =  sv_2mortal(temp_sv);
        return PERL_constant_ISSV;
      }
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 8:
    /* Names all of length 8.  */
    /* FARTHING NOT_ZERO */
    /* Offset 2 gives the best switch position.  */
    switch (name[2]) {
    case 'R':
      if (memEQ(name, "FARTHING", 8)) {
      /*                 ^           */
#ifdef FARTHING
        *nv_return = FARTHING;
        return PERL_constant_ISNV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'T':
      if (memEQ(name, "NOT_ZERO", 8)) {
      /*                 ^           */
#ifdef NOT_ZERO
        *iv_return = (IV) ~(UV)0;
        return PERL_constant_ISUV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

MODULE = ExtTest		PACKAGE = ExtTest
PROTOTYPES: ENABLE
void
constant(sv)
    PREINIT:
#ifdef dXSTARG
	dXSTARG; /* Faster if we have it.  */
#else
	dTARGET;
#endif
	STRLEN		len;
        int		type;
	IV		iv;
	NV		nv;
	const char	*pv;
    INPUT:
	SV *		sv;
        const char *	s = SvPV(sv, len);
    INPUT:
	int		utf8 = SvUTF8(sv);
    PPCODE:
	type = constant(aTHX_ s, len, utf8, &iv, &nv, &pv, &sv);
      /* Return 1 or 2 items. First is error message, or undef if no error.
           Second, if present, is found value */
        switch (type) {
        case PERL_constant_NOTFOUND:
          sv = sv_2mortal(newSVpvf("%s is not a valid ExtTest macro", s));
          PUSHs(sv);
          break;
        case PERL_constant_NOTDEF:
          sv = sv_2mortal(newSVpvf(
	    "Your vendor has not defined ExtTest macro %s, used", s));
          PUSHs(sv);
          break;
        case PERL_constant_ISIV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHi(iv);
          break;
        case PERL_constant_ISNO:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_no);
          break;
        case PERL_constant_ISNV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHn(nv);
          break;
        case PERL_constant_ISPV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, strlen(pv));
          break;
        case PERL_constant_ISPVN:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, iv);
          break;
        case PERL_constant_ISSV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHs(sv);
          break;
        case PERL_constant_ISUNDEF:
          break;
        case PERL_constant_ISUV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHu((UV)iv);
          break;
        case PERL_constant_ISYES:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_yes);
          break;
        default:
          sv = sv_2mortal(newSVpvf(
	    "Unexpected return type %d while processing ExtTest macro %s, used",
               type, s));
          PUSHs(sv);
        }
