#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <linux/sockios.h>
#include <sys/socket.h>
#include <linux/if_arp.h>
#include <linux/socket.h>
#include <sys/ioctl.h>
#include <unistd.h>

int
getMac(unsigned char *mac)
{
	struct  ifreq   ifconf;
	int     sockfd;
	int i = 0;

	sockfd = socket(AF_INET, SOCK_PACKET, ETH_P_ARP);
	if (sockfd < 0)
		return -1;

#ifdef WIFI
	strncpy(ifconf.ifr_name, "eth8", sizeof(ifconf.ifr_name));
#else
	strncpy(ifconf.ifr_name, "eth0", sizeof(ifconf.ifr_name));
#endif
	ifconf.ifr_addr.sa_family = AF_INET;

	i = ioctl(sockfd, SIOCGIFHWADDR, &ifconf);
	if (i < 0)
 		return -1;

 	memcpy(mac, ifconf.ifr_hwaddr.sa_data, 6);
	close(sockfd);

        for(i = (ETH_ALEN - 1); i >=0 ; i--) {
		mac[i]++;
                if (mac[i] != 0)
                        break;
        }
 	return 0;
}

void
setMAC(unsigned char *mac, int id)
{
	int i = 0;
	char cmd[256];

        for(i = (ETH_ALEN - 1); i >=0 ; i--) {
		mac[i]++;
                if (mac[i] != 0)
                        break;
        }

	sprintf(cmd, "/sbin/ip link set eth%d address %.2x:%.2x:%.2x:%.2x:%.2x:%.2x",
		id,
		mac[0],
		mac[1],
		mac[2],
		mac[3],
		mac[4],
		mac[5]
	);
	system(cmd);
}

int
main(void)
{
	unsigned char mac[6];

	system("/sbin/ip link set eth0 up");
	system("/bin/vconfig set_name_type DEV_REPLACE");

#if defined(WIFI)
	system("/bin/vconfig add eth0 3");
	system("/bin/vconfig add eth9 4");
	system("/bin/vconfig set_flag eth8 1 1");
	system("/bin/vconfig set_flag eth3 1 1");
#elif defined(MULTI_HOMING) || defined(AS700)
	system("/bin/vconfig add eth0 1");
	system("/bin/vconfig add eth9 3");
	system("/bin/vconfig add eth9 4");
	system("/bin/vconfig set_flag eth0 1 1");
	system("/bin/vconfig set_flag eth2 1 1");
	system("/bin/vconfig set_flag eth3 1 1");
#else
  #ifdef DLINK
	system("/bin/vconfig add eth0 4");
	system("/bin/vconfig add eth9 2");
  #else
	system("/bin/vconfig add eth0 1");
	system("/bin/vconfig add eth9 3");
  #endif
	system("/bin/vconfig set_flag eth0 1 1");
	system("/bin/vconfig set_flag eth2 1 1");
#endif

	if (getMac(mac) < 0) {
		fprintf(stderr, "Can not get MAC address\n");
		exit(0);
	}

#if defined(WIFI)
	setMAC(mac, 3);
#elif defined(MULTI_HOMING) || defined(AS700)
	setMAC(mac, 2);
	setMAC(mac, 3);
#else
	setMAC(mac, 2);
#endif

	return 0;
}
