#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

typedef unsigned short u16;

#include <linux/mii.h>

unsigned short eeprom_data[] = {
0x4154, 0x840f, 0x040f, 0x880f, 0x040f, 0x8c0f, 0x040f, 0x900f,
0x940f, 0x881f, 0x5902, 0x8000, 0xfa50, 0xfa50, 0x5500, 0x5500,
0x0040, 0xff30, 0x3600, 0xffff, 0x0101, 0x0104, 0x0110, 0x0140, 
0x0180, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
0xffff, 0xffff, 0xffff, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
0x0000, 0x0000, 0x0000, 0x0000, 0xd000, 0x4442, 0x0000, 0x0000,
0x0997, 0x0000, 0x0000, 0x0000 };

int
main(int argc, char **argv)
{
	int fd = 0;
	char *c;
	unsigned int data;
	unsigned short content = 0x8401;

	if (argc == 2) {
		data = strtoul(argv[1], &c, 10);
		if (data & BMCR_ANENABLE)
			content |= 0xf;
		if (data & BMCR_SPEED100)
			content |= 0x4;
		if (data & BMCR_FULLDPLX)
			content |= 0x8;
		eeprom_data[1] = content;
	}

	fd = open("/dev/eeprom", O_RDWR);
	if (!fd) {
		fprintf(stderr, "Can not open /dev/eeprom file\n");
		return -1;
	}

	write(fd, eeprom_data, sizeof(eeprom_data));
	close(fd);
	return 0;
}
