#include <stdlib.h>

#define	BUFF_SIZE	4000
#define ADDR_SIZE	100
#define MAX_BUFF_NUM	400
#define ADDR_NUM	BUFF_SIZE/ADDR_SIZE

struct addrInfo {
	void *address;
	struct addrInfo *next;
};

struct buffInfo {
	void *start;
	void *end;
	int freeaddrnum;
	struct addrInfo *list;
} buffInfo[MAX_BUFF_NUM];

void *raddr;

void
init_buff(void)
{
	int i = 0;

	for (i = 0; i < MAX_BUFF_NUM; i++) {
		buffInfo[i].start = 0;
		buffInfo[i].end = 0;
		buffInfo[i].freeaddrnum = 0;
		buffInfo[i].list = NULL;
	}
}

int
malloc_buff(int UseBuff)
{
	struct addrInfo *addr, *prev;
	void *i = NULL, *data_address = NULL;

	if (UseBuff >= MAX_BUFF_NUM)
		return -1;

	buffInfo[UseBuff].start = malloc(BUFF_SIZE);
	if (!buffInfo[UseBuff].start)
		return -1;

	buffInfo[UseBuff].list = buffInfo[UseBuff].start;
	addr = buffInfo[UseBuff].start;
	prev = addr;
	buffInfo[UseBuff].end = buffInfo[UseBuff].start + BUFF_SIZE;
	addr->address = buffInfo[UseBuff].start + sizeof(struct addrInfo);

	for (i = (buffInfo[UseBuff].start + ADDR_SIZE); 
	     i < buffInfo[UseBuff].end; i += ADDR_SIZE) {
		addr = i;
		data_address = i + sizeof(struct addrInfo);
		addr->address = data_address;
		addr->next = NULL;
		prev->next = addr;
		prev = addr;
		buffInfo[UseBuff].freeaddrnum++;
	}

	return 0;
}

void
*my_malloc(size_t size)
{
	int i = 0;
	int freebuf = MAX_BUFF_NUM;

	if (size > (ADDR_SIZE - sizeof(struct addrInfo)))
		return NULL;

	for (i = 0; i < MAX_BUFF_NUM; i++) {
		if (buffInfo[i].start) {
			if (buffInfo[i].freeaddrnum > 0) {
				buffInfo[i].freeaddrnum--;
				raddr = buffInfo[i].list->address;
				buffInfo[i].list = buffInfo[i].list->next;
				return raddr;
			}
		} else {
			if (freebuf > i)
				freebuf = i;
		}
	}

	if (freebuf < MAX_BUFF_NUM) {
		if (!malloc_buff(freebuf)) {			
			buffInfo[freebuf].freeaddrnum--;
			raddr = buffInfo[freebuf].list->address;
			buffInfo[freebuf].list = buffInfo[freebuf].list->next;
			return raddr;
		}
	}
	return NULL;
}

void
my_free(void *addr)
{
	int i = 0;
	struct addrInfo *addrinfo;

	for (i = 0; i < MAX_BUFF_NUM; i++) {
		if (addr > buffInfo[i].start &&
		    addr < buffInfo[i].end) {
			addrinfo = (struct addrInfo *)(addr - sizeof(struct addrInfo));
			addrinfo->next = buffInfo[i].list;
			buffInfo[i].list = addrinfo;
			buffInfo[i].freeaddrnum++;
			if (buffInfo[i].freeaddrnum == ADDR_NUM)
				free(buffInfo[i].start);
			break;
		}
	}
}
