/************************************************************************/
/*                                                                      */
/* Sentry - Port Scan Detector                                          */
/*                                                                      */
/* Author: Craig H. Rowland <crowland@psionic.com>                      */
/*									*/
/* Created: 10-12-97                                                    */
/* Modified: 04-12-99                                                   */
/*                                                                      */
/* Send all changes/modifications/bugfixes to the above addresses.      */
/*                                                                      */
/*                                                                      */
/* This software is Copyright(c) 1997-98 Craig H. Rowland               */
/*                                                                      */
/* Disclaimer:								*/
/*									*/
/* All software distributed by Craig H. Rowland ("the author") and	*/
/* Psionic Systems is distributed AS IS and carries NO WARRANTY or	*/
/* GUARANTEE OF ANY KIND. End users of the software acknowledge that	*/
/* they will not hold the author, Psionic Systems, and any employer of	*/
/* the author liable for failure or non-function of a software		*/
/* product. YOU ARE USING THIS PRODUCT AT YOUR OWN RISK			*/
/*									*/
/* Licensing restrictions apply. See the license that came with this	*/
/* file for more information or visit http://www.psionic.com for more	*/
/* information.								*/
/*                                                                      */
/* $Id: init.h,v 1.2 2001/12/31 03:58:47 sukent Exp $*/
/************************************************************************/



#define VERSION "1.0"

#include <stdio.h>
#include <syslog.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <netdb.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <stdarg.h>
#include <assert.h>
#include <sys/param.h>
#include <sys/types.h>
#ifndef _LINUX_C_LIB_VERSION
#include <sys/socket.h>
#include <sys/stat.h>
#include <netinet/in.h>
#endif
#include <arpa/inet.h>

/* These are probably ok. Be sure you change the Makefile if you */
/* change the path */
#define CONFIG_FILE "/etc/iplog.conf"

#define FW_CONFIG_FILE "/etc/sysconfig/.firewall/fw"
/* Angus ++ 2001/05/14 */
#define SSMTP_CONFIG_FILE "/etc/ssmtp/ssmtp.conf"

/* The location of Wietse Venema's TCP Wrapper hosts.deny file */
#define WRAPPER_HOSTS_DENY "/etc/hosts.deny"

/* The default syslog is as daemon.notice. You can also use */
/* any of the facilities from syslog.h to send messages to (LOCAL0, etc) */
#define SYSLOG_FACILITY LOG_DAEMON
#define SYSLOG_LEVEL LOG_NOTICE


#include "handler.h"
#include "util.h"

#ifdef DEBUG 
	#undef DEBUG
#endif

#define Log //

#define ERROR -1
#define TRUE 1
#define FALSE 0
#define MAXBUF 1024
/* max size of an IP address plus NULL */
#define IPMAXBUF 16
/* max sockets we can open */
#define MAXSOCKS 64

/* Really is about 1025, but we don't need the length for our purposes */
#define DNSMAXBUF 255


/* prototypes */
int DisposeConnect(char *, int);
int InitConfig(char *);

