// $Id: pidof.c,v 1.1.1.1 2002/07/30 03:11:19 xxx Exp $
// $Log: pidof.c,v $
// Revision 1.1.1.1  2002/07/30 03:11:19  xxx
//
//
// Revision 1.2  2001/12/31 03:58:51  perry
// Add Id & Log
//

/* ps.c:
 *
 * Copyright (C) 1998  Kenneth Albanowski <kjahds@kjahds.com>
 * Copyright (C) 1999  D. Jeff Dionne     <jeff@rt-control.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include <linux/autoconf.h>

#include <fcntl.h>
#include <sys/types.h>
#include <string.h>
#include <sys/stat.h>
#include <dirent.h>
#include <pwd.h>
#include <grp.h>
#include <time.h>
#include <linux/major.h>
#include <linux/types.h>
#include <sys/time.h>
#include <asm/param.h>
#include <math.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
/* 2001/11/03 Steve ++ */
#include "pidof.h"

struct progpid *progpid = NULL, *tmppid;

char psbuf[256];
char name[40];
int pid, state;
char statec;
int ppid, pgrp, session;
dev_t tty;

#define MAJOR(x) ((x) >> 8)
#define MINOR(x) ((x) & 0xff)
#ifndef isdigit
#define isdigit(X) ((X) >= '0' && (X) <= '9' ? 1 : 0)
#endif

struct progpid
*pidof(char *prog)
{
	int i;
	int h;
	DIR * d;
	struct dirent * de;
	char *ext;
	int l;
        int utime, stime, start_time;

	d = opendir("/proc");
	if (!d)
		return NULL;

	tmppid = progpid;
	while ((de = readdir(d))) {
		for(i=0;i<strlen(de->d_name);i++)
			if (!isdigit(de->d_name[i]))
				goto next;

		sprintf(psbuf, "/proc/%s/stat", de->d_name);
		
		h = open(psbuf, O_RDONLY);
		
		if (h==-1)
			continue;
			
		l = read(h, psbuf, 255);
		if (l<=0) {
			/* perror("Unable to read status"); */
			close(h);
			continue;
		}
		
		psbuf[l] = '\0';
		psbuf[255] = '\0';
		
		ext = strrchr(psbuf, ')');
		ext[0] = '\0';

		statec = ext[2];

		ext += 4;
		
		ppid = atoi(ext);
		ext = strchr(ext, ' ')+1;

		pgrp = atoi(ext);
		ext = strchr(ext, ' ')+1;
		
		session = atoi(ext);
		ext = strchr(ext, ' ')+1;

		tty = atoi(ext);
		ext = strchr(ext, ' ')+1;

		//tpgid
		ext = strchr(ext, ' ')+1;
		
		//flags
		ext = strchr(ext, ' ')+1;

		//min_flt
		ext = strchr(ext, ' ')+1;

		//cmin_flt
		ext = strchr(ext, ' ')+1;

		//maj_flt
		ext = strchr(ext, ' ')+1;

		//cmaj_flt
		ext = strchr(ext, ' ')+1;

		utime = atoi(ext);
		ext = strchr(ext, ' ')+1;

		stime = atoi(ext);
		ext = strchr(ext, ' ')+1;
		
		//cutime
		ext = strchr(ext, ' ')+1;

		//cstime
		ext = strchr(ext, ' ')+1;
		
		//priority
		ext = strchr(ext, ' ')+1;
		
		//nice
		ext = strchr(ext, ' ')+1;
		
		//timeout
		ext = strchr(ext, ' ')+1;

		//it_real_value
		ext = strchr(ext, ' ')+1;

		start_time = atoi(ext);
		
		ext = strchr(psbuf, '(');
		ext++;
		strcpy(name, ext);
		
		pid = atoi(psbuf);
		
		state = statec;
		
		close(h);

		if (!(strcmp(name, prog)))
		{
			tmppid = (struct progpid *)malloc(sizeof(struct progpid));
			if (!tmppid) {
				freepid();
				return NULL;
			}
			tmppid->id = pid;
			tmppid->next = progpid;
			progpid = tmppid;
		}		
	next:
	}
	
	closedir(d);
	return progpid;
}

void
freepid(void)
{
	while (progpid) {
		tmppid = progpid->next;
		free(progpid);
		progpid = tmppid;
	}
}
