/* $Id: generators.h,v 1.36 2004/09/13 17:44:49 jhewlett Exp $ */
/*
** Copyright (C) 1998-2002 Martin Roesch <roesch@sourcefire.com>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __GENERATORS_H__
#define __GENERATORS_H__

#define GENERATOR_SNORT_ENGINE        1

#define GENERATOR_TAG                 2
#define    TAG_LOG_PKT                1

#define GENERATOR_SPP_PORTSCAN      100 /* OK r:1 c:0 p:0*/
#define     PORTSCAN_SCAN_DETECT        99
#define     PORTSCAN_INTER_INFO         99
#define     PORTSCAN_SCAN_END           99

#define GENERATOR_SPP_MINFRAG       101 /* OK NULL */
#define     MINFRAG_ALERT_ID            98

#define GENERATOR_SPP_HTTP_DECODE   102	/* OK NULL */
#define     HTTP_DECODE_UNICODE_ATTACK  97
#define     HTTP_DECODE_CGINULL_ATTACK  97
#define     HTTP_DECODE_LARGE_METHOD    97
#define     HTTP_DECODE_MISSING_URI     97
#define     HTTP_DECODE_DOUBLE_ENC      97
#define     HTTP_DECODE_ILLEGAL_HEX     97
#define     HTTP_DECODE_OVERLONG_CHAR   97


#define GENERATOR_SPP_DEFRAG        103	/* OK NULL */
#define     DEFRAG_FRAG_OVERFLOW        96
#define     DEFRAG_FRAGS_DISCARDED      96

#define GENERATOR_SPP_SPADE         104 /* OK NULL */
#define     SPADE_ANOM_THRESHOLD_EXCEEDED   95
#define     SPADE_ANOM_THRESHOLD_ADJUSTED   95

#define GENERATOR_SPP_BO            105 /* OK r:1 c:0 p:0*/
#define     BO_TRAFFIC_DETECT           94

#define GENERATOR_SPP_RPC_DECODE    106	/* OK r:1 c:25 p:3*/
#define     RPC_FRAG_TRAFFIC                1
#define     RPC_MULTIPLE_RECORD             2
#define     RPC_LARGE_FRAGSIZE              3
#define     RPC_INCOMPLETE_SEGMENT          4
/* smallj ++ 2005/06/29 */
#define     RPC_FRAG_TRAFFIC_SID            93
#define     RPC_MULTIPLE_RECORD_SID         93
#define     RPC_LARGE_FRAGSIZE_SID          93
#define     RPC_INCOMPLETE_SEGMENT_SID      93
/* smallj -- */
#define GENERATOR_SPP_STREAM2       107	/* OK NULL */
#define GENERATOR_SPP_STREAM3       108	/* OK NULL */
#define GENERATOR_SPP_TELNET_NEG    109	/* OK NULL */

#define GENERATOR_SPP_UNIDECODE     110	/* OK NULL */
#define     UNIDECODE_CGINULL_ATTACK        92
#define     UNIDECODE_DIRECTORY_TRAVERSAL   92
#define     UNIDECODE_UNKNOWN_MAPPING       92
#define     UNIDECODE_INVALID_MAPPING       92

#define GENERATOR_SPP_STREAM4       111 /* OK r:1 c:0 p:3 */
#define     STREAM4_STEALTH_ACTIVITY            91
#define     STREAM4_EVASIVE_RST                 91
#define     STREAM4_EVASIVE_RETRANS             91
#define     STREAM4_WINDOW_VIOLATION            91
#define     STREAM4_DATA_ON_SYN                 91
#define     STREAM4_STEALTH_FULL_XMAS           91
#define     STREAM4_STEALTH_SAPU                91
#define     STREAM4_STEALTH_FIN_SCAN            91
#define     STREAM4_STEALTH_NULL_SCAN           91
#define     STREAM4_STEALTH_NMAP_XMAS_SCAN      91
#define     STREAM4_STEALTH_VECNA_SCAN          91
#define     STREAM4_STEALTH_NMAP_FINGERPRINT    91
#define     STREAM4_STEALTH_SYN_FIN_SCAN        91
#define     STREAM4_FORWARD_OVERLAP             91
#define     STREAM4_TTL_EVASION                 91
#define     STREAM4_EVASIVE_RETRANS_DATA        91
#define     STREAM4_EVASIVE_RETRANS_DATASPLIT   91
#define     STREAM4_MULTIPLE_ACKED              91
#define     STREAM4_EMERGENCY                   91
#define     STREAM4_SUSPEND                     91

#define GENERATOR_SPP_ARPSPOOF      112 /* OK r:1 c:0 p:3 */
#define     ARPSPOOF_UNICAST_ARP_REQUEST         90
#define     ARPSPOOF_ETHERFRAME_ARP_MISMATCH_SRC  90
#define     ARPSPOOF_ETHERFRAME_ARP_MISMATCH_DST  90
#define     ARPSPOOF_ARP_CACHE_OVERWRITE_ATTACK   90

#define GENERATOR_SPP_FRAG2         113 /* OK r:1 c:0 p:5 */
#define     FRAG2_OVERSIZE_FRAG                   89
#define     FRAG2_TEARDROP                        89
#define     FRAG2_TTL_EVASION                     89
#define     FRAG2_OVERLAP                         89
#define     FRAG2_DUPFIRST                        89
#define     FRAG2_MEM_EXCEED                      89
#define     FRAG2_OUTOFORDER                      89
#define     FRAG2_IPOPTIONS                       89
#define     FRAG2_EMERGENCY                       89
#define     FRAG2_SUSPEND                         89

#define GENERATOR_SPP_FNORD         114 /* OK NULL */
#define     FNORD_NOPSLED                         88

#define GENERATOR_SPP_ASN1          115 /* OK NULL */
#define     ASN1_INDEFINITE_LENGTH                87
#define     ASN1_INVALID_LENGTH                   87
#define     ASN1_OVERSIZED_ITEM                   87
#define     ASN1_SPEC_VIOLATION                   87
#define     ASN1_DATUM_BAD_LENGTH                 87


#define GENERATOR_SNORT_DECODE      116 /* OK r:1 c:25 p:3 */
#define     DECODE_NOT_IPV4_DGRAM                 86
#define     DECODE_IPV4_INVALID_HEADER_LEN        86
#define     DECODE_IPV4_DGRAM_LT_IPHDR            86
#define     DECODE_IPV4OPT_BADLEN                 86
#define     DECODE_IPV4OPT_TRUNCATED              86

#define     DECODE_TCP_DGRAM_LT_TCPHDR            86
#define     DECODE_TCP_INVALID_OFFSET             86
#define     DECODE_TCP_LARGE_OFFSET               86

#define     DECODE_TCPOPT_BADLEN                  86
#define     DECODE_TCPOPT_TRUNCATED               86
#define     DECODE_TCPOPT_TTCP                    86
#define     DECODE_TCPOPT_OBSOLETE                86
#define     DECODE_TCPOPT_EXPERIMENT              86

#define     DECODE_UDP_DGRAM_LT_UDPHDR            86
#define     DECODE_UDP_DGRAM_INVALID_LENGTH       86
#define     DECODE_UDP_DGRAM_SHORT_PACKET         86

#define     DECODE_ICMP_DGRAM_LT_ICMPHDR          86
#define     DECODE_ICMP_DGRAM_LT_TIMESTAMPHDR     86
#define     DECODE_ICMP_DGRAM_LT_ADDRHDR          86
#define     DECODE_IPV4_DGRAM_UNKNOWN             86

#define     DECODE_ARP_TRUNCATED                  86
#define     DECODE_EAPOL_TRUNCATED                86
#define     DECODE_EAPKEY_TRUNCATED               86
#define     DECODE_EAP_TRUNCATED                  86

#define     DECODE_BAD_PPPOE                      86
#define     DECODE_BAD_VLAN                       86
#define     DECODE_BAD_VLAN_ETHLLC                86
#define     DECODE_BAD_VLAN_OTHER                 86
#define     DECODE_BAD_80211_ETHLLC               86 
#define     DECODE_BAD_80211_OTHER                86

#define     DECODE_BAD_TRH                        86
#define     DECODE_BAD_TR_ETHLLC                  86
#define     DECODE_BAD_TR_MR_LEN                  86
#define     DECODE_BAD_TRHMR                      86

#define GENERATOR_SPP_SCAN2         117	/* OK r:1 c:0 p:0 */
#define     SCAN_TYPE                             85

#define GENERATOR_SPP_CONV         118 /* OK  r:1 c:0 p:5 */
#define     CONV_BAD_IP_PROTOCOL                  84

/*
**  HttpInspect Generator IDs
**
**  IMPORTANT::
**    Whenever events are added to the internal HttpInspect
**    event queue, you must also add the event here.  The
**    trick is that whatever the number is in HttpInspect,
**    it must be +1 when you define it here.
*/
#define GENERATOR_SPP_HTTP_INSPECT_CLIENT           119 /* OK r:1 c:0 p:3*/
/* smallj ++ 2005/06/29 */
#define HI_EO_CLIENT_ASCII_SID          83   
#define HI_EO_CLIENT_DOUBLE_DECODE_SID  83   
#define HI_EO_CLIENT_U_ENCODE_SID       83   
#define HI_EO_CLIENT_BARE_BYTE_SID      83   
#define HI_EO_CLIENT_BASE36_SID         83   
#define HI_EO_CLIENT_UTF_8_SID          83   
#define HI_EO_CLIENT_IIS_UNICODE_SID    83   
#define HI_EO_CLIENT_MULTI_SLASH_SID    83   
#define HI_EO_CLIENT_IIS_BACKSLASH_SID  83   
#define HI_EO_CLIENT_SELF_DIR_TRAV_SID  83   
#define HI_EO_CLIENT_DIR_TRAV_SID       83  
#define HI_EO_CLIENT_APACHE_WS_SID      83  
#define HI_EO_CLIENT_IIS_DELIMITER_SID  83  
#define HI_EO_CLIENT_NON_RFC_CHAR_SID   83  
#define HI_EO_CLIENT_OVERSIZE_DIR_SID   83  
#define HI_EO_CLIENT_LARGE_CHUNK_SID    83  
#define HI_EO_CLIENT_PROXY_USE_SID      83  
#define HI_EO_CLIENT_WEBROOT_DIR_SID    83  
#if 0
#define     HI_CLIENT_ASCII                         83   /* done */
#define     HI_CLIENT_DOUBLE_DECODE                 83   /* done */
#define     HI_CLIENT_U_ENCODE                      83   /* done */
#define     HI_CLIENT_BARE_BYTE                     83   /* done */
#define     HI_CLIENT_BASE36                        83   /* done */
#define     HI_CLIENT_UTF_8                         83   /* done */
#define     HI_CLIENT_IIS_UNICODE                   83   /* done */
#define     HI_CLIENT_MULTI_SLASH                   83   /* done */
#define     HI_CLIENT_IIS_BACKSLASH                 83   /* done */
#define     HI_CLIENT_SELF_DIR_TRAV                 83  /* done */
#define     HI_CLIENT_DIR_TRAV                      83  /* done */
#define     HI_CLIENT_APACHE_WS                     83  /* done */
#define     HI_CLIENT_IIS_DELIMITER                 83  /* done */
#define     HI_CLIENT_NON_RFC_CHAR                  83  /* done */
#define     HI_CLIENT_OVERSIZE_DIR                  83  /* done */
#define     HI_CLIENT_LARGE_CHUNK                   83  /* done */
#define     HI_CLIENT_PROXY_USE                     83  /* done */
#define     HI_CLIENT_WEBROOT_DIR                   83  /* done */
#endif
/* smallj -- */

#define GENERATOR_SPP_HTTP_INSPECT_ANOM_SERVER      120 /* OK r:1 c:0 p:3*/
#define     HI_ANOM_SERVER_ALERT                    82   /* OK NULL */

#define GENERATOR_FLOW_PORTSCAN                     121 /* OK r:1 c:1 p:2*/
#define     FLOW_SCANNER_FIXED_ALERT                 81
#define     FLOW_SCANNER_SLIDING_ALERT               81
#define     FLOW_TALKER_FIXED_ALERT                  81
#define     FLOW_TALKER_SLIDING_ALERT                81

#define GENERATOR_PSNG                             122 /* OK r:0 c:0 p:3*/
#define     PSNG_TCP_PORTSCAN                      80
#define     PSNG_TCP_DECOY_PORTSCAN                80
#define     PSNG_TCP_PORTSWEEP                     80
#define     PSNG_TCP_DISTRIBUTED_PORTSCAN          80
#define     PSNG_TCP_FILTERED_PORTSCAN             80
#define     PSNG_TCP_FILTERED_DECOY_PORTSCAN       80
#define     PSNG_TCP_PORTSWEEP_FILTERED            80
#define     PSNG_TCP_FILTERED_DISTRIBUTED_PORTSCAN 80

#define     PSNG_IP_PORTSCAN                       80
#define     PSNG_IP_DECOY_PORTSCAN                 80
#define     PSNG_IP_PORTSWEEP                      80
#define     PSNG_IP_DISTRIBUTED_PORTSCAN           80
#define     PSNG_IP_FILTERED_PORTSCAN              80
#define     PSNG_IP_FILTERED_DECOY_PORTSCAN        80
#define     PSNG_IP_PORTSWEEP_FILTERED             80
#define     PSNG_IP_FILTERED_DISTRIBUTED_PORTSCAN  80

#define     PSNG_UDP_PORTSCAN                      80
#define     PSNG_UDP_DECOY_PORTSCAN                80
#define     PSNG_UDP_PORTSWEEP                     80
#define     PSNG_UDP_DISTRIBUTED_PORTSCAN          80
#define     PSNG_UDP_FILTERED_PORTSCAN             80
#define     PSNG_UDP_FILTERED_DECOY_PORTSCAN       80
#define     PSNG_UDP_PORTSWEEP_FILTERED            80
#define     PSNG_UDP_FILTERED_DISTRIBUTED_PORTSCAN 80

#define     PSNG_ICMP_PORTSWEEP                    80
#define     PSNG_ICMP_PORTSWEEP_FILTERED           80

#define     PSNG_OPEN_PORT                         80

#define GENERATOR_SPP_CLAMAV			    123 /* OK r:1 c:0 p:0*/
#define     CLAMAV_VIRUSFOUND                      79

/*  This is where all the alert messages will be archived for each
    internal alerts */

#define ARPSPOOF_UNICAST_ARP_REQUEST_STR "(arpspoof) Unicast ARP request"
#define ARPSPOOF_ETHERFRAME_ARP_MISMATCH_SRC_STR \
"(arpspoof) Ethernet/ARP Mismatch request for Source"
#define ARPSPOOF_ETHERFRAME_ARP_MISMATCH_DST_STR \
"(arpspoof) Ethernet/ARP Mismatch request for Destination"
#define ARPSPOOF_ARP_CACHE_OVERWRITE_ATTACK_STR \
"(arpspoof) Attempted ARP cache overwrite attack"

#define ASN1_INDEFINITE_LENGTH_STR "(asn1) Indefinite ASN.1 length encoding"
#define ASN1_INVALID_LENGTH_STR "(asn1) Invalid ASN.1 length encoding"
#define ASN1_OVERSIZED_ITEM_STR "(asn1) ASN.1 oversized item, possible overflow"
#define ASN1_SPEC_VIOLATION_STR  "(asn1) ASN.1 spec violation, possible overflow"
#define ASN1_DATUM_BAD_LENGTH_STR "(asn1) ASN.1 Attack: Datum length > packet length"

#define BO_TRAFFIC_DETECT_STR "(spo_bo) Back Orifice Traffic detected"

#define FNORD_NOPSLED_IA32_STR "(fnord) Possible Mutated IA32 NOP Sled detected"
#define FNORD_NOPSLED_HPPA_STR "(fnord) Possible Mutated HPPA NOP Sled detected"
#define FNORD_NOPSLED_SPARC_STR "(fnord) Possible Mutated SPARC NOP Sled detected"

#define FRAG2_DUPFIRST_STR "(frag2) Duplicate first fragments"
#define FRAG2_IPOPTIONS_STR "(frag2) IP Options on Fragmented Packet"
#define FRAG2_OUTOFORDER_STR "(frag2) Out of order fragments" 
#define FRAG2_OVERLAP_STR "(frag2) Overlapping new fragment (probable fragroute)"
#define FRAG2_OVERSIZE_FRAG_STR "(frag2) Oversized fragment, probable DoS"
#define FRAG2_TEARDROP_STR "(frag2) Teardrop attack"
#define FRAG2_TTL_EVASION_STR "(frag2) TTL Limit Exceeded (reassemble) detection"
#define FRAG2_EMERGENCY_STR "(frag2) Shifting to Emergency Session Mode"
#define FRAG2_SUSPEND_STR "(frag2) Shifting to Suspend Mode"



#define HTTP_DECODE_LARGE_METHOD_STR "(http_decode) A large HTTP method was received"
#define HTTP_DECODE_MISSING_URI_STR "(http_decode) HTTP request without URI"
#define HTTP_DECODE_DOUBLE_ENC_STR  "(http_decode) Double Hex Encoding Received"
#define HTTP_DECODE_ILLEGAL_HEX_STR "(http_decode) Illegal URL hex encoding"
#define HTTP_DECODE_OVERLONG_CHAR_STR "(http_decode) Overlong Unicode character received"

#define STREAM4_MULTIPLE_ACKED_STR "(stream4) Multiple Acked Packets (possible fragroute)"
#define STREAM4_DATA_ON_SYN_STR  "(stream4) DATA ON SYN detection"
#define STREAM4_STEALTH_NMAP_FINGERPRINT_STR "(stream4) NMAP FINGERPRINT (stateful) detection"
#define STREAM4_STEALTH_FULL_XMAS_STR "(stream4) STEALTH ACTIVITY (Full XMAS scan) detection"
#define STREAM4_STEALTH_SAPU_STR "(stream4) STEALTH ACTIVITY (SAPU scan) detection"
#define STREAM4_STEALTH_FIN_SCAN_STR "(stream4) STEALTH ACTIVITY (FIN scan) detection"
#define STREAM4_STEALTH_SYN_FIN_SCAN_STR "(stream4) STEALTH ACTIVITY (SYN FIN scan) detection"
#define STREAM4_STEALTH_NULL_SCAN_STR "(stream4) STEALTH ACTIVITY (NULL scan) detection"
#define STREAM4_STEALTH_NMAP_XMAS_SCAN_STR "(stream4) STEALTH ACTIVITY (XMAS scan) detection"
#define STREAM4_STEALTH_VECNA_SCAN_STR "(stream4) STEALTH ACTIVITY (Vecna scan) detection"
#define STREAM4_STEALTH_ACTIVITY_STR "(stream4) STEALTH ACTIVITY (unknown) detection"
#define STREAM4_EVASIVE_RST_STR "(stream4) possible EVASIVE RST detection"
#define STREAM4_TTL_EVASION_STR "(stream4) TTL LIMIT Exceeded"
#define STREAM4_EVASIVE_RETRANS_STR "(stream4) Possible RETRANSMISSION detection"
#define STREAM4_WINDOW_VIOLATION_STR "(stream4) WINDOW VIOLATION detection"
#define STREAM4_EVASIVE_RETRANS_DATA_STR \
 "(stream4) TCP CHECKSUM CHANGED ON RETRANSMISSION (possible fragroute) detection"
#define STREAM4_FORWARD_OVERLAP_STR "(stream4) FORWARD OVERLAP detection"
#define STREAM4_EVASIVE_RETRANS_DATASPLIT_STR \
"(stream4) TCP TOO FAST RETRANSMISSION WITH DIFFERENT DATA SIZE (possible fragroute) detection"
#define STREAM4_EMERGENCY_STR "(stream4) Shifting to Emergency Session Mode"
#define STREAM4_SUSPEND_STR "(stream4) Shifting to Suspend Mode"


#define DECODE_NOT_IPV4_DGRAM_STR "(IDP_decoder) WARNING: Not IPv4 datagram!"
#define DECODE_IPV4_INVALID_HEADER_LEN_STR "(IDP_decoder) WARNING: hlen < IP_HEADER_LEN!"
#define DECODE_IPV4_DGRAM_LT_IPHDR_STR "(IDP_decoder) WARNING: IP dgm len < IP Hdr len!"
#define DECODE_IPV4OPT_BADLEN_STR      "(IDP_decoder): Ipv4 Options found with bad lengths"
#define DECODE_IPV4OPT_TRUNCATED_STR   "(IDP_decoder): Truncated Ipv4 Options"

#define DECODE_TCP_DGRAM_LT_TCPHDR_STR "(IDP_decoder) TCP packet len is smaller than 20 bytes!"
#define DECODE_TCP_INVALID_OFFSET_STR "(IDP_decoder) WARNING: TCP Data Offset is less than 5!"
#define DECODE_TCP_LARGE_OFFSET_STR "(IDP_decoder) WARNING: TCP Header length exceeds packet length!"

#define DECODE_TCPOPT_BADLEN_STR      "(IDP_decoder): Tcp Options found with bad lengths"
#define DECODE_TCPOPT_TRUNCATED_STR   "(IDP_decoder): Truncated Tcp Options"
#define DECODE_TCPOPT_TTCP_STR        "(IDP_decoder): T/TCP Detected"
#define DECODE_TCPOPT_OBSOLETE_STR    "(IDP_decoder): Obsolete TCP Options found"
#define DECODE_TCPOPT_EXPERIMENT_STR  "(IDP_decoder): Experimental Tcp Options found"



#define DECODE_UDP_DGRAM_LT_UDPHDR_STR "(IDP_decoder) WARNING: Truncated UDP Header!"
#define DECODE_UDP_DGRAM_INVALID_LENGTH_STR "(IDP_decoder): Invalid UDP header, length field < 8"
#define DECODE_UDP_DGRAM_SHORT_PACKET_STR "(IDP_decoder): Short UDP packet, length field > payload length"

#define DECODE_ICMP_DGRAM_LT_ICMPHDR_STR "(IDP_decoder) WARNING: ICMP Header Truncated!"
#define DECODE_ICMP_DGRAM_LT_TIMESTAMPHDR_STR "(IDP_decoder) WARNING: ICMP Timestamp Header Truncated!"
#define DECODE_ICMP_DGRAM_LT_ADDRHDR_STR "(IDP_decoder) WARNING: ICMP Address Header Truncated!"
#define DECODE_IPV4_DGRAM_UNKNOWN_STR "(IDP_decoder) Unknown Datagram decoding problem!"
#define DECODE_ARP_TRUNCATED_STR "(IDP_decoder) WARNING: Truncated ARP!"
#define DECODE_EAPOL_TRUNCATED_STR "(IDP_decoder) WARNING: Truncated EAP Header!"
#define DECODE_EAPKEY_TRUNCATED_STR "(IDP_decoder) WARNING: EAP Key Truncated!"
#define DECODE_EAP_TRUNCATED_STR "(IDP_decoder) WARNING: EAP Header Truncated!"
#define DECODE_BAD_PPPOE_STR "(IDP_decoder) WARNING: Bad PPPOE frame detected!"
#define DECODE_BAD_VLAN_STR "(IDP_decoder) WARNING: Bad VLAN Frame!"
#define DECODE_BAD_VLAN_ETHLLC_STR "(IDP_decoder) WARNING: Bad LLC header!"
#define DECODE_BAD_VLAN_OTHER_STR "(IDP_decoder) WARNING: Bad Extra LLC Info!"
#define DECODE_BAD_80211_ETHLLC_STR "(IDP_decoder) WARNING: Bad 802.11 LLC header!"
#define DECODE_BAD_80211_OTHER_STR "(IDP_decoder) WARNING: Bad 802.11 Extra LLC Info!"

#define DECODE_BAD_TRH_STR "(IDP_decoder) WARNING: Bad Token Ring Header!"
#define DECODE_BAD_TR_ETHLLC_STR "(IDP_decoder) WARNING: Bad Token Ring ETHLLC Header!"
#define DECODE_BAD_TR_MR_LEN_STR "(IDP_decoder) WARNING: Bad Token Ring MRLENHeader!"
#define DECODE_BAD_TRHMR_STR "(IDP_decoder) WARNING: Bad Token Ring MR Header!"

/* smallj ++ 2005/06/29 */
#if 0
#define SCAN2_PREFIX_STR "(portscan2) Portscan detected from "
#else
//#define SCAN2_PREFIX_STR "(portscan2) Portscan detected!"
#define SCAN2_PREFIX_STR "(portscan) Portscan detected!" //2005/7/14 Justin++
#endif
/* smallj -- */
#define CONV_BAD_IP_PROTOCOL_STR "(conversation) Bad IP protocol!"

#define RPC_FRAG_TRAFFIC_STR "(rpc_decode) Fragmented RPC Records"
#define RPC_MULTIPLE_RECORD_STR "(rpc_decode) Multiple RPC Records"
#define RPC_LARGE_FRAGSIZE_STR  "(rpc_decode) Large RPC Record Fragment"
#define RPC_INCOMPLETE_SEGMENT_STR "(rpc_decode) Incomplete RPC segment"

#define PSNG_TCP_PORTSCAN_STR "(portscan) TCP Portscan"
#define PSNG_TCP_DECOY_PORTSCAN_STR "(portscan) TCP Decoy Portscan"
#define PSNG_TCP_PORTSWEEP_STR "(portscan) TCP Portsweep"
#define PSNG_TCP_DISTRIBUTED_PORTSCAN_STR "(portscan) TCP Distributed Portscan"
#define PSNG_TCP_FILTERED_PORTSCAN_STR "(portscan) TCP Filtered Portscan"
#define PSNG_TCP_FILTERED_DECOY_PORTSCAN_STR "(portscan) TCP Filtered Decoy Portscan"
#define PSNG_TCP_FILTERED_DISTRIBUTED_PORTSCAN_STR "(portscan) TCP Filtered Distributed Portscan"
#define PSNG_TCP_PORTSWEEP_FILTERED_STR "(portscan) TCP Filtered Portsweep"

#define PSNG_IP_PORTSCAN_STR "(portscan) IP Protocol Scan"
#define PSNG_IP_DECOY_PORTSCAN_STR "(portscan) IP Decoy Protocol Scan"
#define PSNG_IP_PORTSWEEP_STR "(portscan) IP Protocol Sweep"
#define PSNG_IP_DISTRIBUTED_PORTSCAN_STR "(portscan) IP Distributed Protocol Scan"
#define PSNG_IP_FILTERED_PORTSCAN_STR "(portscan) IP Filtered Protocol Scan"
#define PSNG_IP_FILTERED_DECOY_PORTSCAN_STR "(portscan) IP Filtered Decoy Protocol Scan"
#define PSNG_IP_FILTERED_DISTRIBUTED_PORTSCAN_STR "(portscan) IP Filtered Distributed Protocol Scan"
#define PSNG_IP_PORTSWEEP_FILTERED_STR "(portscan) IP Filtered Protocol Sweep"

#define PSNG_UDP_PORTSCAN_STR "(portscan) UDP Portscan"
#define PSNG_UDP_DECOY_PORTSCAN_STR "(portscan) UDP Decoy Portscan"
#define PSNG_UDP_PORTSWEEP_STR "(portscan) UDP Portsweep"
#define PSNG_UDP_DISTRIBUTED_PORTSCAN_STR "(portscan) UDP Distributed Portscan"
#define PSNG_UDP_FILTERED_PORTSCAN_STR "(portscan) UDP Filtered Portscan"
#define PSNG_UDP_FILTERED_DECOY_PORTSCAN_STR "(portscan) UDP Filtered Decoy Portscan"
#define PSNG_UDP_FILTERED_DISTRIBUTED_PORTSCAN_STR "(portscan) UDP Filtered Distributed Portscan"
#define PSNG_UDP_PORTSWEEP_FILTERED_STR "(portscan) UDP Filtered Portsweep"

#define PSNG_ICMP_PORTSWEEP_STR "(portscan) ICMP Sweep"
#define PSNG_ICMP_PORTSWEEP_FILTERED_STR "(portscan) ICMP Filtered Sweep"

#define PSNG_OPEN_PORT_STR "(portscan) Open Port"

#define CLAMAV_VIRUSFOUND_STR "(clamav) Virus Found:"

#endif /* __GENERATORS_H__ */
