#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include "log.h"

void
logMsg(char *logtime, char *msg)
{
	FILE *fp;
	char buf[256], *p;

	p = strstr(msg, LOG_ITEM);
	if (!p)
		return;
	else
		p += strlen(LOG_ITEM);
	sprintf(buf, "%s %s", logtime, p);
	fp = fopen(LOG_MSG_FILE, "r+");

	fseek(fp, 0, SEEK_END);
	fprintf(fp, "%s\n", buf);
	fclose(fp);
}

int
getchainName(unsigned long timeinfo, char *chainName)
{
	struct tm *chain_tm;

	chain_tm = localtime(&timeinfo);
	if (!chain_tm)
		return -1;

	sprintf(chainName, "%.2d%.2d%.2d%.2d%.2d%.2d",
		chain_tm->tm_year%100,
		chain_tm->tm_mon+1,
		chain_tm->tm_mday,
		chain_tm->tm_hour,
		chain_tm->tm_min,
		chain_tm->tm_sec
	);

	return 0;
}

void
alarmMsg(char *msg)
{
	struct alarmInfo info;
	struct alarmLog alarm;
	char chain[20], buf[256], path[128], *p;
	FILE *fp;
	float len;

	p = strstr(msg, ALARM_ITEM);
	if (!p)
		return;
	else
		p += strlen(ALARM_ITEM);

	sscanf(p, ALARM_MSG_FMT,
		&alarm.datalen,
		&alarm.chain,
		&alarm.curtime);

	len = ((float)alarm.datalen) / 1024.0;
	if (getchainName(alarm.chain, chain) < 0)
		return;

	sprintf(path, "%s/%s/alarm", TRAFFIC_INFO_DIR, chain);
	fp = fopen(path, "r+");
	if (!fp)
		return;

	fgets(buf, sizeof(buf), fp);
	sscanf(buf, ALARM_INFO_FMT,
		&info.lasttime,
		&info.len,
		&info.limit,
		&info.flag
	);

	if (info.flag != 0) {
		if (info.lasttime != alarm.curtime) {
			FILE *alarmfp;
			alarmfp = fopen(ALARM_MSG_FILE, "r+");
			fseek(alarmfp, 0, SEEK_END);
			fprintf(alarmfp, "%s %fK/sec %lu\n",
				chain,
				info.len,
				info.lasttime);
			fclose(alarmfp);
			info.flag = 0;
			info.len = 0.0;
		}
	} else {
		if (info.lasttime == alarm.curtime && 
		   ((info.len+len) >= info.limit))
			info.flag = 1;
		else if (info.lasttime != alarm.curtime)
			info.len = 0.0;
	}

	info.lasttime = alarm.curtime;
	info.len += len;
	ftruncate(fileno(fp), 0);
	fprintf(fp, "%lu %f %f %d\n",
		info.lasttime,
		info.len,
		info.limit,
		info.flag
	);
	fclose(fp);
}
