#include <linux/types.h>
#include <linux/errno.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/fs.h>
#include <asm/arch/gpio.h>
#include <asm/arch/freset.h>
#include <asm/hardware.h>

static int init_status;

static int
gpio_read(struct file *file, char *buf, size_t count, loff_t *fpos)
{
	int  rem, len;
	int value = 0;
	char temp[128];

	gpio_line_get(IXP425_GPIO_PIN_8, &value);
	len = sprintf(temp, "%d\n", value);

	rem = len - *fpos;
	if (rem <= 0)  {
		*fpos = len;
		return 0;
	}
	if (rem > count)
		rem = count;

	memcpy(buf, temp+(*fpos), rem);
	*fpos += rem;

	return rem;
}

static int
gpio_open(struct inode *inode, struct file *file)
{
	return 0;
}

static struct file_operations gpio_fops = {
	read:	gpio_read,
	open:	gpio_open,
};

static void __exit freset_cleanup_module(void)
{
	if (init_status)
		unregister_chrdev(FRESET_GPIO_MAJOR, "gpio");
}

static int __init freset_init_module(void)
{
	int result;

	init_status = 0;
	result = register_chrdev(FRESET_GPIO_MAJOR, "gpio", &gpio_fops);
	if (result < 0)   {
		printk(KERN_ERR "Factory Reset: can't register char device\n");
    		return result;
	}

	init_status = 1;

	printk(KERN_INFO "Factory Reset Drivers" FRESET_VERSION "\n");
	return 0;
}

module_init(freset_init_module);
module_exit(freset_cleanup_module);
EXPORT_NO_SYMBOLS;
