/*
 * FileName:    IxInterfacesNums.h
 * Author: Intel Corporation
 * Created:     Thu Jun 15 09:45:16 GMT 2000
 * Description:
 *    Defines the interface numbers for each interface (in the
 *    view of SNMP) on the managed device.
 *
 * -- Intel Copyright Notice --
 * INTEL CONFIDENTIAL
 *
 * Copyright 2000-2002 Intel Corporation All Rights Reserved.
 *
 * The source code contained or described herein and all documents
 * related to the source code ("Material") are owned by Intel Corporation
 * or its suppliers or licensors.  Title to the Material remains with
 * Intel Corporation or its suppliers and licensors.  The Material
 * contains trade secrets and proprietary and confidential information of
 * Intel or its suppliers and licensors.  The Material is protected by
 * worldwide copyright and trade secret laws and treaty provisions. No
 * part of the Material may be used, copied, reproduced, modified,
 * published, uploaded, posted, transmitted, distributed, or disclosed in
 * any way without Intel's prior express written permission.
 *
 * No license under any patent, copyright, trade secret or other
 * intellectual property right is granted to or conferred upon you by
 * disclosure or delivery of the Materials, either expressly, by
 * implication, inducement, estoppel or otherwise.  Any license under
 * such intellectual property rights must be express and approved by
 * Intel in writing.
 *
 * For further details, please see the file README.TXT distributed with
 * this software.
 * -- End Intel Copyright Notice --
 */

#ifndef __IXINTERFACESNUMS_H
#define __IXINTERFACESNUMS_H

#define IF_ETH1  20001
#define IF_ETH2  20002

#define IF_ADSL  30001
#define IF_ADSL_ITLV 31001
#define IF_ADSL_FAST 32001

#define IF_HDSL 40001
#define IF_GSHDSL 40002
#define IF_GCI 50001
#define IF_GCI_C1_B1 51001
#define IF_GCI_C2_B1 51002
#define IF_GCI_C3_B1 51003
#define IF_GCI_C4_B1 51004
#define IF_GCI_C5_B1 51005
#define IF_GCI_C6_B1 51006
#define IF_GCI_C7_B1 51007
#define IF_GCI_C8_B1 51008

#define IF_GCI_C1_B2 52001
#define IF_GCI_C2_B2 52002
#define IF_GCI_C3_B2 52003
#define IF_GCI_C4_B2 52004
#define IF_GCI_C5_B2 52005
#define IF_GCI_C6_B2 52006
#define IF_GCI_C7_B2 52007
#define IF_GCI_C8_B2 52008

#define IF_GCI_C1_SIG 53001
#define IF_GCI_C2_SIG 53002
#define IF_GCI_C3_SIG 53003
#define IF_GCI_C4_SIG 53004
#define IF_GCI_C5_SIG 53005
#define IF_GCI_C6_SIG 53006
#define IF_GCI_C7_SIG 53007
#define IF_GCI_C8_SIG 53008

#define IF_GCI_C1_MON 54001
#define IF_GCI_C2_MON 54002
#define IF_GCI_C3_MON 54003
#define IF_GCI_C4_MON 54004
#define IF_GCI_C5_MON 54005
#define IF_GCI_C6_MON 54006
#define IF_GCI_C7_MON 54007
#define IF_GCI_C8_MON 54008

#define IF_ATM 60001
#define IF_AAL0 120001
#define IF_AAL1 70001
#define IF_AAL2 80001
#define IF_AAL34 90001
#define IF_AAL5 100001

#define IF_PPP 110001

#endif /* __IXINTERFACESNUMS_H */
