
/*   
 * -- Intel Copyright Notice --
 * INTEL CONFIDENTIAL
 *
 * Copyright 1999-2002 Intel Corporation All Rights Reserved.
 *
 * The source code contained or described herein and all documents
 * related to the source code ("Material") are owned by Intel Corporation
 * or its suppliers or licensors.  Title to the Material remains with
 * Intel Corporation or its suppliers and licensors.  The Material
 * contains trade secrets and proprietary and confidential information of
 * Intel or its suppliers and licensors.  The Material is protected by
 * worldwide copyright and trade secret laws and treaty provisions. No
 * part of the Material may be used, copied, reproduced, modified,
 * published, uploaded, posted, transmitted, distributed, or disclosed in
 * any way without Intel's prior express written permission.
 *
 * No license under any patent, copyright, trade secret or other
 * intellectual property right is granted to or conferred upon you by
 * disclosure or delivery of the Materials, either expressly, by
 * implication, inducement, estoppel or otherwise.  Any license under
 * such intellectual property rights must be express and approved by
 * Intel in writing.
 *
 * For further details, please see the file README.TXT distributed with
 * this software.
 * -- End Intel Copyright Notice --
 */

/*
 * Modification history
 *
 * Date       Author              Description
 * -------------------------------------------------------------
 * 04/29/99   pjb  	  Initial release.
 * 04/03/02   so	  Modified for ixp425
 * -------------------------------------------------------------
 */




#if !defined(CTRLEADDRESSMAP_HEADER)
#define	CTRLEADDRESSMAP_HEADER


/**********CTRLE REGISTER ADDRESSES********************/

/* COMMON */

#define    TXCOMMANDREG 							0x00 
#define    RXCOMMANDREG 							0x01 
#define    RXCOMAVREG 								0x03 
#define    BLCKBADDRREG 							0x08 
#define    BLCKLENREG 								0x0C 
#define    BLCKDATAREG 								0x0E 
#define    CTEAD_LT_MINNOISEMARGIN_DN				0x040 
#define    CTEAD_LT_MAXPSD_DN					0x046 
#define    CTEAD_LT_MAXAGGPOWERLEVEL_DN 			0x048 
#define    CTEAD_UTOPIA_LEVEL					0x04A 
#define    CTEAD_LT_CARRIERMASK 				0x050 
#define    CTEAD_LT_RAMODE_DN					0x070 
#define    CTEAD_LT_INTERL_PLANNED_BITRATE_DN	0x074 
#define    CTEAD_LT_RARATIO_DN 					0x08C 
#define    CTEAD_LT_RADOWNSHIFTMARGIN_DN 			0x090 
#define    CTEAD_LT_RADOWNSHIFTINTERVAL_DN 		0x094 
#define    CTEAD_LT_INTERL_MAXDELAY_DN 			0x09C 
#define    CTEAD_ACC_BER_FAST					0x0A3 
#define    CTEAD_ACC_BER_IL 						0x0B0 
#define    CTEAD_ITU_VENDORID_COUNTRYCODE 		0x0BA 
#define    CTEAD_ADSL_REQUESTED_INFO_0 			0x0E0 
#define    CTEAD_MODEM_STATUS					0x100 
#define    CTEAD_RVERSION_NEAR_END 				0x102 
#define    CTEAD_RVERSION_FAR_END 				0x103 
#define    CTEAD_RVENDOR_NEAR_END_LSB			0x104 
#define    CTEAD_RVENDOR_FAR_END_LSB 				0x106 

/* LT */
#define    CTEAD_LT_FAR_RELCAPACITYOCC_DN_LSB	0x108 
#define    CTEAD_LT_FAR_NOISEMARGIN_DN 			0x10A 
#define    CTEAD_LT_FAR_OUTPUTPOWER_UP 			0x10B 
#define    CTEAD_LT_FAR_ATTENUATION_DN 			0x10C 
#define    CTEAD_LT_FAR_ATTAINABLE_BITRATE_LSB 	0x10E 
#define    CTEAD_LT_NEAR_RELCAPACITYOCC_UP_LSB 	0x110 
#define    CTEAD_LT_NEAR_NOISEMARGIN_UP 			0x112 
#define    CTEAD_LT_NEAR_OUTPUTPOWER_DN 			0x113 
#define    CTEAD_LT_NEAR_ATTENUATION_UP 			0x114 
#define    CTEAD_LT_NEAR_ATTAINABLE_BITRATE_LSB 	0x116 
#define    CTEAD_LT_NEAR_CARRIER_LOAD			0x118 

/*NT */
#define    CTEAD_NT_NEAR_RELCAPACITYOCC_DN_LSB 	0x108 
#define    CTEAD_NT_NEAR_NOISEMARGIN_DN 			0x10A 
#define    CTEAD_NT_NEAR_OUTPUTPOWER_UP 			0x10B 
#define    CTEAD_NT_NEAR_ATTENUATION_DN 			0x10C 
#define    CTEAD_NT_FAR_RELCAPACITYOCC_UP_LSB	0x110 
#define    CTEAD_NT_FAR_NOISEMARGIN_UP 			0x112 
#define    CTEAD_NT_FAR_OUTPUTPOWER_DN 			0x113 
#define    CTEAD_NT_FAR_ATTENUATION_UP 			0x114 
#define    CTEAD_NT_FAR_CARRIER_LOAD 				0x118 

/*COMMON */
#define    CTEAD_NEAR_INT_CHANNELDATA_LSB 		0x1A0 
#define    CTEAD_NEAR_FAST_CHANNELDATA_LSB 		0x1A2 
#define    CTEAD_FAR_INT_CHANNELDATA_LSB 			0x1A4 
#define    CTEAD_FAR_FAST_CHANNELDATA_LSB 		0x1A6 
#define    CTEAD_NEAR_FEC_NI_LSB 					0x1B0 
#define    CTEAD_NEAR_BITMAP_STATUS 				0x1E0 
#define    R_OPEN_FAILED_REG 						0x1E4 
#define    R_SELFTEST_RESULTS_REG 				0x1E5 
#define    CTEAD_FUNC_FIELD_1FC 					0x1FC 
#define    CTEAD_FUNC_FIELD_1FD 					0x1FD 
#define    CTEAD_CONTROLLER_SW_VERSION  			0x1FE 


/*
 * Added by Basis Comm.
 */

#define CTEAD_ADSL_REG_ADDR_LSB		0x1E8
#define CTEAD_ADSL_REG_ADDR_MSB		0x1E9

#define CTEAD_ADSL_REG_DATA_LSB		0x1EC
#define CTEAD_ADSL_REG_DATA_MSB		0x1ED

#define ADSL_DYING_GASP_REG		0x1FA

#endif










