
/*   
 * -- Intel Copyright Notice --
 * INTEL CONFIDENTIAL
 *
 * Copyright 1999-2002 Intel Corporation All Rights Reserved.
 *
 * The source code contained or described herein and all documents
 * related to the source code ("Material") are owned by Intel Corporation
 * or its suppliers or licensors.  Title to the Material remains with
 * Intel Corporation or its suppliers and licensors.  The Material
 * contains trade secrets and proprietary and confidential information of
 * Intel or its suppliers and licensors.  The Material is protected by
 * worldwide copyright and trade secret laws and treaty provisions. No
 * part of the Material may be used, copied, reproduced, modified,
 * published, uploaded, posted, transmitted, distributed, or disclosed in
 * any way without Intel's prior express written permission.
 *
 * No license under any patent, copyright, trade secret or other
 * intellectual property right is granted to or conferred upon you by
 * disclosure or delivery of the Materials, either expressly, by
 * implication, inducement, estoppel or otherwise.  Any license under
 * such intellectual property rights must be express and approved by
 * Intel in writing.
 *
 * For further details, please see the file README.TXT distributed with
 * this software.
 * -- End Intel Copyright Notice --
 */

/*
 * Modification history
 *
 * Date       Author              Description
 * -------------------------------------------------------------
 * 04/29/99   pjb  	  Initial release.
 * 04/03/02   so	  Modified for ixp425
 * -------------------------------------------------------------
 */



#if !defined(CTRLEREADWRITEHEADER)
#define	CTRLEREADWRITEHEADER



#include <stdio.h>

typedef	 int bool;
typedef	 unsigned char uint8;

#define	RECTRLE_BUFFSIZE (128)
#define RECTRLE_MAX_DATA (64)

#if  CTRLE_USE_SERIAL
bool wrctrle(const unsigned char* pval,const unsigned int address,const unsigned	int number);
bool rdctrle(unsigned char *pval,const unsigned int address,const unsigned int number);
#endif

#if  !(CTRLE_USE_SERIAL)
bool wrctrle(unsigned int lineNum,const unsigned char* pval,const unsigned int address,const unsigned int number);
bool rdctrle(unsigned int lineNum,unsigned char *pval,const unsigned int address,const unsigned int number);
#endif



#endif
