/*
 * -- Intel Copyright Notice --
 * INTEL CONFIDENTIAL
 *
 * Copyright 2002 Intel Corporation All Rights Reserved.
 *
 * The source code contained or described herein and all documents
 * related to the source code ("Material") are owned by Intel Corporation
 * or its suppliers or licensors.  Title to the Material remains with
 * Intel Corporation or its suppliers and licensors.  The Material
 * contains trade secrets and proprietary and confidential information of
 * Intel or its suppliers and licensors.  The Material is protected by
 * worldwide copyright and trade secret laws and treaty provisions. No
 * part of the Material may be used, copied, reproduced, modified,
 * published, uploaded, posted, transmitted, distributed, or disclosed in
 * any way without Intel's prior express written permission.
 *
 * No license under any patent, copyright, trade secret or other
 * intellectual property right is granted to or conferred upon you by
 * disclosure or delivery of the Materials, either expressly, by
 * implication, inducement, estoppel or otherwise.  Any license under
 * such intellectual property rights must be express and approved by
 * Intel in writing.
 *
 * For further details, please see the file README.TXT distributed with
 * this software.
 * -- End Intel Copyright Notice --
*/



#if !defined(DETONATORHEADER)
#define	DETONATORHEADER


/*
 * INTEL DEFINITIONS....
 */

#define	MODEM_STATUS_UP			0x20
#define	MODEM_STATUS_DOWN		0x00
#define	MODEM_STATUS_WAIT_FOR_INIT	0x08
#define	MODEM_STATUS_INITIALIZING	0x10

#define	ADSL_CLOSE_ORDERLY_SHUTDOWN	0x0e
#define	ADSL_SEND_DYING_GASP		0x0d
#define ADSL_DYING_GASP_ENABLE		0x02

#define	ADSL_OPEN			0x03
#define	ADSL_OPEN_GLITE			0x07
#define	ADSL_OPEN_GDMT			0x06
#define	ADSL_OPEN_ANSI			0x05
#define	ADSL_OPEN_MULTIMODE		0x08

#define	ADSL_CLOSE			0x04
#define ADSL_SELFTEST_SEND_TONES  	0x0F



#define	ADSL_SELFTEST_LONG		0x02
#define	ADSL_SELFTEST_SHORT		0x01



#define MODEM_REG_WRITE_CMD			0x10 
#define MODEM_REG_READ_CMD			0x11 

#define	SACHEM_VERSION_ADDRESS		0  /* ?? */
#define	SACHEM_VERSION_LENGTH		0  /* ?? */

#define	MODEM_LOAD_BLOCK		0x13
#define MODEM_DUMP_BLOCK		0x12
#define MODEM_JUMP_ADDR			0x14

#define	GET_NEAR_ITU_VENDOR_ID		0x32
#define	GET_FAR_ITU_VENDOR_ID		0x33
#define	GET_OPERATIONAL_MODE		0x31 


#define ADSL_SIGNAL_LOST		0x41 
#define	ADSL_SUICIDE_REQUEST		0x42 




#define	GABARIT_BASE_ADDRESS		0 /* ?? */
#define	GABARIT_BLOCK_LENGTH		0 /* ?? */
#define	LOG_BASE_ADDRESS_LT		0 /* ?? */
#define	LOG_BASE_ADDRESS_NT		0 /* ?? */
#define	LOG_BLOCK_LENGTH		0 /* ?? */







#define	PILOTUP		16  /*		//17-1	15;//16-1  */
#define	 PILOTDOWN		64  /*	  //65-1  63;//64-1	   */
#define	UPSTRLIMIT		31  /* ///32-1			   */
#define	DNSTRLIMIT		32  /* //33-1  was 47;//48-1	   */

#define	 TONESPACING	4.3125	  /* //kHz */
#define	 NUMBER_OF_TONES	256
#define	 NUMBER_OF_LOGWORDS 8192


/*
 * ATU-R Rx Commands opcodes.
 */

#define  ADSL_OperationalMode_Available 0x12
#define  ADSL_OperatialMode_Nack  0x13
#define  ADSL_Near_End_Identification_Available 0x14
#define  ADSL_Near_End_Identification_Nack  0x15
#define  ADSL_Far_End_Identification_Available 0x16
#define  ADSL_Far_End_Identification_Nack  0x17
#define  ADSL_Open_Rejected  0x21
#define  ADSL_Open_Failed 0x22
#define  ADSL_Connection_Opened  0x24
#define  ADSL_Signal_Lost 0x41
#define  ADSL_Connection_Closed  0x25
#define  ADSL_Close_Rejected  0x26
#define  ADSL_Selftest_Results 0x27
#define  ADSL_Orderly_Shutdown_Executed 0x28
#define  ADSL_Orderly_Shutdown_Rejected 0x29
#define  ADSL_Orderly_Shutdown_Ack 0x30
#define  ADSL_Orderly_Shutdown_Nack 0x31
#define  ADSL_Dying_Gasp_Sent 0x34
#define  ADSL_Dying_Gasp_Rejected 0x35
#define  ADSL_Suicide_Request 0x42
#define  ADSL_Unknown_Opcode 0x60
#define  ADSL_Modem_Reg_Available 0x61
#define  ADSL_Modem_Reg_Write_Ack 0x62
#define  ADSL_Modem_Reg_Write_Nack 0x63
#define  ADSL_Modem_Block_Available 0x64
#define  ADSL_Modem_Block_Dump_Ack 0x65
#define  ADSL_Modem_Block_Dump_Nack 0x66







#endif

