/**
 * @file IxAtmdTxCfgIf_p.h
 *
 * @author Intel Corporation
 * @date 17 March 2002
 *
 * @brief IxAtmdAcc Tx Control
 *
 * This file defines the error counters used in the Atmd Tx code
 * and the initialisation functions
 *
 * -- Intel Copyright Notice --
 *
 * @par
 * INTEL CONFIDENTIAL
 *
 * @par
 * Copyright 2002 Intel Corporation All Rights Reserved.
 *
 * @par
 * The source code contained or described herein and all documents
 * related to the source code ("Material") are owned by Intel Corporation
 * or its suppliers or licensors.  Title to the Material remains with
 * Intel Corporation or its suppliers and licensors.  The Material
 * contains trade secrets and proprietary and confidential information of
 * Intel or its suppliers and licensors.  The Material is protected by
 * worldwide copyright and trade secret laws and treaty provisions. No
 * part of the Material may be used, copied, reproduced, modified,
 * published, uploaded, posted, transmitted, distributed, or disclosed in
 * any way without Intel's prior express written permission.
 *
 * @par
 * No license under any patent, copyright, trade secret or other
 * intellectual property right is granted to or conferred upon you by
 * disclosure or delivery of the Materials, either expressly, by
 * implication, inducement, estoppel or otherwise.  Any license under
 * such intellectual property rights must be express and approved by
 * Intel in writing.
 *
 * @par
 * For further details, please see the file README.TXT distributed with
 * this software.
 * -- End Intel Copyright Notice --
 */

#ifndef IXATMDTX_CFGIF_P_H
#define IXATMDTX_CFGIF_P_H

#include "IxTypes.h"

/**
* @brief TxCfgIf initialisation function
* @note - this function should be used once
*
* @return @li IX_SUCCESS on success
* @return @li IX_FAIL on error
*/
IX_STATUS
ixAtmdAccTxCfgIfInit (void);

/**
* @brief TxCfgIf stats display function
* @note  This function uses printf
*
* @return none
*/
void
ixAtmdAccTxCfgIfStatsShow (void);

/**
* @brief TxCfgIf sttas reset function
*
* @return none
*/
void
ixAtmdAccTxCfgIfStatsReset (void);

/**
* @brief  display tx port configuration
*
* @return none
*/
void
ixAtmdAccTxCfgIfPortShow (IxAtmLogicalPort port);

/**
* @brief  display tx configuration
*
* @return none
*/
void
ixAtmdAccTxCfgIfChannelShow (IxAtmLogicalPort port);

#endif /* IXATMDTXCFGIF_P_H */


