/**
 * @file    IxAtmCodeletMain.h
 *
 * @date    27-May-2000
 *
 * @brief   IxAtmCodelet scenarios header file.
 * -- Intel Copyright Notice --
 *
 * @par
 * INTEL CONFIDENTIAL
 *
 * @par
 * Copyright 2002 Intel Corporation All Rights Reserved.
 *
 * @par
 * The source code contained or described herein and all documents
 * related to the source code ("Material") are owned by Intel Corporation
 * or its suppliers or licensors.  Title to the Material remains with
 * Intel Corporation or its suppliers and licensors.  The Material
 * contains trade secrets and proprietary and confidential information of
 * Intel or its suppliers and licensors.  The Material is protected by
 * worldwide copyright and trade secret laws and treaty provisions. No
 * part of the Material may be used, copied, reproduced, modified,
 * published, uploaded, posted, transmitted, distributed, or disclosed in
 * any way without Intel's prior express written permission.
 *
 * @par
 * No license under any patent, copyright, trade secret or other
 * intellectual property right is granted to or conferred upon you by
 * disclosure or delivery of the Materials, either expressly, by
 * implication, inducement, estoppel or otherwise.  Any license under
 * such intellectual property rights must be express and approved by
 * Intel in writing.
 *
 * @par
 * For further details, please see the file README.TXT distributed with
 * this software.
 * -- End Intel Copyright Notice --
 *
 */
#ifndef IX_ATMCODELETMAIN_H
#define IX_ATMCODELETMAIN_H

/*
 * System defined include files.
 */
#include <stdio.h>

/*
 * User defined include files.
 */
#include "ix_ossl.h"
#include "IxTypes.h"
#include "IxAtmCodelet.h"
#include "IxAtmCodelet_p.h"

/*
 * Defines and macros
 */

/*
 * Variable declarations global to this file. Externs are followed by
 * statics.
 */

/*
 * Function definitions
 */
PUBLIC IX_STATUS
ixAtmCodeletMainUtopiaLoopback (void);

PUBLIC IX_STATUS
ixAtmCodeletMainSoftwareLoopback (void);

PUBLIC IX_STATUS
ixAtmCodeletMainRemoteLoopback (void);
#endif /*IX_ATMCODELETMAIN_H*/
