/**
 * @file    IxAtmCodelet_p.h
 *
 * @date    31-May-2002
 *
 * @brief   Private header file for the IXP425 Atm codelet
 * -- Intel Copyright Notice --
 *
 * @par
 * INTEL CONFIDENTIAL
 *
 * @par
 * Copyright 2002 Intel Corporation All Rights Reserved.
 *
 * @par
 * The source code contained or described herein and all documents
 * related to the source code ("Material") are owned by Intel Corporation
 * or its suppliers or licensors.  Title to the Material remains with
 * Intel Corporation or its suppliers and licensors.  The Material
 * contains trade secrets and proprietary and confidential information of
 * Intel or its suppliers and licensors.  The Material is protected by
 * worldwide copyright and trade secret laws and treaty provisions. No
 * part of the Material may be used, copied, reproduced, modified,
 * published, uploaded, posted, transmitted, distributed, or disclosed in
 * any way without Intel's prior express written permission.
 *
 * @par
 * No license under any patent, copyright, trade secret or other
 * intellectual property right is granted to or conferred upon you by
 * disclosure or delivery of the Materials, either expressly, by
 * implication, inducement, estoppel or otherwise.  Any license under
 * such intellectual property rights must be express and approved by
 * Intel in writing.
 *
 * @par
 * For further details, please see the file README.TXT distributed with
 * this software.
 * -- End Intel Copyright Notice --
 *
 * @sa IxAtmCodelet.h
 *
 */

#ifndef IXATMCODELET_P_H
#define IXATMCODELET_P_H

/*
 * System defined includes
 */

/*
 * User defined includes
 */
#include "ix_ossl.h"

/*
 * #defines and macros used in this file.
 */
#define IX_ATMCODELET_MBUF_SIZE               (2000)  /* Mbuf cluster block size                       */
#define IX_ATMCODELET_START_VPI               (1)     /* The first VPI value                           */
#define IX_ATMCODELET_START_VCI               (32)    /* The first VCI value                           */
#define IX_ATMCODELET_NUM_MBUFS_IN_SW_MBUF_Q  (128)   /* Number of mbus in the software queue          */
#define IX_ATMCODELET_RX_FREE_Q_LOW_THRESHOLD (8)     /* Notification trigger threshold value          */
#define IX_ATMCODELET_DEFAULT_CLP             (0)     /* Default Cell Loss Priority value for ATM cell */
#define IX_ATMCODELET_LOG printf

/*
 * Typedefs
 */

typedef struct
{
    unsigned int txPdus;
    unsigned int txBytes;
    unsigned int rxPdus;
    unsigned int rxBytes;
    unsigned int txDonePdus;
    unsigned int rxFreeBuffers;
} IxAtmCodeletStats;

/*
 * Function declarations
 */

#endif
/* IXATMCODELET_P_H */
