#ifdef __linux

#include <linux/config.h>
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/sched.h>
#include <asm/semaphore.h>

#include "IxTypes.h"
#include "IxDmaAccCodelet.h"

EXPORT_SYMBOL(ixDmaAccCodeletInit);
EXPORT_SYMBOL(ixDmaAccCodeletTestPerform);

int tLength = 128;
IxDmaTransferMode tMode = 0;
IxDmaAddressingMode aMode = 0;
IxDmaTransferWidth tWidth = 0;

MODULE_PARM(tLength, "i");
MODULE_PARM(tMode, "i");
MODULE_PARM(aMode, "i");
MODULE_PARM(tWidth, "i");

static int __init DmaInitModule(void)
{
	printk("Load DmaAcc Codelet\n");
	ixDmaAccCodeletInit(0);

	printk("tLength = %d, tMode = %d, aMode = %d, tWidth = %d\n",
		tLength, tMode, aMode, tWidth);
	ixDmaAccCodeletTestPerform(tLength, tMode, aMode, tWidth);
	ixOsServTaskSleep(10);

	printk("tLength = %d, tMode = %d, aMode = %d, tWidth = %d\n",
		tLength, tMode, aMode, tWidth);
	ixDmaAccCodeletTestPerform(tLength, tMode, aMode, tWidth);
	ixOsServTaskSleep(10);

	printk("tLength = %d, tMode = %d, aMode = %d, tWidth = %d\n",
		tLength, tMode, aMode, tWidth);
	ixDmaAccCodeletTestPerform(tLength, tMode, aMode, tWidth);
	ixOsServTaskSleep(10);

	printk("tLength = %d, tMode = %d, aMode = %d, tWidth = %d\n",
		tLength, tMode, aMode, tWidth);
	ixDmaAccCodeletTestPerform(tLength, tMode, aMode, tWidth);
	ixOsServTaskSleep(10);

	ixDmaAccCodeletTestPerform(tLength, tMode, aMode, tWidth);
	ixOsServTaskSleep(10);
	return 0;
}

static void __exit DmaExitModule(void)
{
	printk("Unload DmaAcc Codelet\n");
}

module_init(DmaInitModule);
module_exit(DmaExitModule);


#endif
