/**
 * @file IxHssAccCodeletSymbols.c
 *
 * @author Intel Corporation
 * @date 14-Oct-2002
 *
 * @brief This file declares exported symbols for linux kernel module builds.
 *
 * -- Intel Copyright Notice --
 *
 * @par
 * INTEL CONFIDENTIAL
 *
 * @par
 * Copyright 2002 Intel Corporation All Rights Reserved.
 *
 * @par
 * The source code contained or described herein and all documents
 * related to the source code ("Material") are owned by Intel Corporation
 * or its suppliers or licensors.  Title to the Material remains with
 * Intel Corporation or its suppliers and licensors.  The Material
 * contains trade secrets and proprietary and confidential information of
 * Intel or its suppliers and licensors.  The Material is protected by
 * worldwide copyright and trade secret laws and treaty provisions. No
 * part of the Material may be used, copied, reproduced, modified,
 * published, uploaded, posted, transmitted, distributed, or disclosed in
 * any way without Intel's prior express written permission.
 *
 * @par
 * No license under any patent, copyright, trade secret or other
 * intellectual property right is granted to or conferred upon you by
 * disclosure or delivery of the Materials, either expressly, by
 * implication, inducement, estoppel or otherwise.  Any license under
 * such intellectual property rights must be express and approved by
 * Intel in writing.
 *
 * @par
 * For further details, please see the file README.TXT distributed with
 * this software.
 * -- End Intel Copyright Notice --
 */

#ifdef __linux

#include <linux/config.h>
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/sched.h>

#include "IxHssAccCodelet.h"

EXPORT_SYMBOL(ixHssAccCodeletConfigure);
EXPORT_SYMBOL(ixHssAccCodeletPacketisedServiceStart);
EXPORT_SYMBOL(ixHssAccCodeletPacketisedServiceRun);
EXPORT_SYMBOL(ixHssAccCodeletPacketisedServiceStop);
EXPORT_SYMBOL(ixHssAccCodeletChannelisedServiceStart);
EXPORT_SYMBOL(ixHssAccCodeletChannelisedServiceRun);
EXPORT_SYMBOL(ixHssAccCodeletChannelisedServiceStop);
EXPORT_SYMBOL(ixHssAccCodeletShow);
EXPORT_SYMBOL(ixHssAccCodeletShowReset);
EXPORT_SYMBOL(ixHssAccCodeletCodeletLoopbackGet);
EXPORT_SYMBOL(ixHssAccCodeletCodeletLoopbackSet);
EXPORT_SYMBOL(ixHssAccCodeletHssLoopbackGet);
EXPORT_SYMBOL(ixHssAccCodeletHssLoopbackSet);

extern int test_main (void);

static int demo_func(void *unused)
{
    return test_main();
}

static int __init hss_init_module(void)
{
#ifdef DEBUG
    printk("\n\n"__FUNCTION__": addr=%p\n\n", hss_init_module);
#endif
    printk("Load Intel CSR Codelet: HSS Demo.\n");
    kernel_thread(demo_func, NULL, CLONE_SIGHAND);
    return 0;
}

static void __init hss_cleanup_module(void)
{
    printk("Unload Intel CSR Codelet: HSS Demo.\n");
}

module_init(hss_init_module);
module_exit(hss_cleanup_module);

#endif /* __linux */
