/** 
 * @file IxUSBRNDISEnd.h
 *
 * -- Intel Copyright Notice --
 *
 * @brief useful values for the RNDIS END driver
 *
 * @par
 * INTEL CONFIDENTIAL
 *
 * @par
 * Copyright 2002 Intel Corporation All Rights Reserved.
 *
 * @par
 * The source code contained or described herein and all documents
 * related to the source code ("Material") are owned by Intel Corporation
 * or its suppliers or licensors.  Title to the Material remains with
 * Intel Corporation or its suppliers and licensors.  The Material
 * contains trade secrets and proprietary and confidential information of
 * Intel or its suppliers and licensors.  The Material is protected by
 * worldwide copyright and trade secret laws and treaty provisions. No
 * part of the Material may be used, copied, reproduced, modified,
 * published, uploaded, posted, transmitted, distributed, or disclosed in
 * any way without Intel's prior express written permission.
 *
 * @par
 * No license under any patent, copyright, trade secret or other
 * intellectual property right is granted to or conferred upon you by
 * disclosure or delivery of the Materials, either expressly, by
 * implication, inducement, estoppel or otherwise.  Any license under
 * such intellectual property rights must be express and approved by
 * Intel in writing.
 *
 * @par
 * For further details, please see the file README.TXT distributed with
 * this software.
 * -- End Intel Copyright Notice --
*/

/**
 * @ingroup IxUSBRNDIS
 *
 * @defgroup IxUSBRNDISEnd IXP4xx USB RNDIS End Driver Codelet (IxUSBRNDIS) API
 *
 * @brief IXP4xx codelet for RNDIS End API
 *
 * @{
 */

/**
 * @def RNDIS_END_INET_ADDR
 *
 * @brief RNDIS END driver with inet address
 */
#define RNDIS_END_INET_ADDR "192.168.1.1"

/**
 * @def RNDIS_END_MAC_ADDRESS 
 *
 * @brief RNDIS END driver with MAC address
 */
#define RNDIS_END_MAC_ADDRESS { 0x00, 0x00, 0x00, 0x00, 0x00, 0x02 }

/**
 * @fn rndisInt(void *pDrvCtrl, int packet)
 *
 * @brief RNDIS END hook for receiving packets 
 */
PUBLIC void	rndisInt(void *pDrvCtrl, int packet);

/** @} defgroup IxUSBRNDISEnd*/
