/**
 * @file IxEthAccSymbols.c
 *
 * @author Intel Corporation
 * @date 04-Oct-2002
 *
 * @brief This file declares exported symbols for linux kernel module builds.
 *
 * -- Intel Copyright Notice --
 *
 * @par
 * INTEL CONFIDENTIAL
 *
 * @par
 * Copyright 2002 Intel Corporation All Rights Reserved.
 *
 * @par
 * The source code contained or described herein and all documents
 * related to the source code ("Material") are owned by Intel Corporation
 * or its suppliers or licensors.  Title to the Material remains with
 * Intel Corporation or its suppliers and licensors.  The Material
 * contains trade secrets and proprietary and confidential information of
 * Intel or its suppliers and licensors.  The Material is protected by
 * worldwide copyright and trade secret laws and treaty provisions. No
 * part of the Material may be used, copied, reproduced, modified,
 * published, uploaded, posted, transmitted, distributed, or disclosed in
 * any way without Intel's prior express written permission.
 *
 * @par
 * No license under any patent, copyright, trade secret or other
 * intellectual property right is granted to or conferred upon you by
 * disclosure or delivery of the Materials, either expressly, by
 * implication, inducement, estoppel or otherwise.  Any license under
 * such intellectual property rights must be express and approved by
 * Intel in writing.
 *
 * @par
 * For further details, please see the file README.TXT distributed with
 * this software.
 * -- End Intel Copyright Notice --
 */

#ifdef __linux

#include <linux/module.h>
#include "IxEthAcc.h"
#include "IxEthAccDataPlane_p.h"

EXPORT_SYMBOL(ixEthAccInit);
EXPORT_SYMBOL(ixEthAccPortInit);
EXPORT_SYMBOL(ixEthAccPortTxFrameSubmit);
EXPORT_SYMBOL(ixEthAccPortTxDoneCallbackRegister);
EXPORT_SYMBOL(ixEthAccPortRxCallbackRegister);
EXPORT_SYMBOL(ixEthAccPortRxFreeReplenish);
EXPORT_SYMBOL(ixEthAccPortEnable);
EXPORT_SYMBOL(ixEthAccPortDisable);
EXPORT_SYMBOL(ixEthAccPortEnabledQuery);
EXPORT_SYMBOL(ixEthAccPortPromiscuousModeClear);
EXPORT_SYMBOL(ixEthAccPortPromiscuousModeSet);
EXPORT_SYMBOL(ixEthAccPortUnicastMacAddressSet);
EXPORT_SYMBOL(ixEthAccPortUnicastMacAddressGet);
EXPORT_SYMBOL(ixEthAccPortMulticastAddressJoin);
EXPORT_SYMBOL(ixEthAccPortMulticastAddressLeave);
EXPORT_SYMBOL(ixEthAccPortUnicastAddressShow);
EXPORT_SYMBOL(ixEthAccPortMulticastAddressShow);
EXPORT_SYMBOL(ixEthAccPortDuplexModeSet);
EXPORT_SYMBOL(ixEthAccPortDuplexModeGet);
EXPORT_SYMBOL(ixEthAccPortTxFrameAppendFCSEnable);
EXPORT_SYMBOL(ixEthAccPortTxFrameAppendFCSDisable);
EXPORT_SYMBOL(ixEthAccPortRxFrameAppendFCSEnable);
EXPORT_SYMBOL(ixEthAccPortRxFrameAppendFCSDisable);
EXPORT_SYMBOL(ixEthAccTxSchedulingDisciplineSet);
EXPORT_SYMBOL(ixEthAccMibIIStatsGet);
EXPORT_SYMBOL(ixEthAccMibIIStatsGetClear);
EXPORT_SYMBOL(ixEthAccMibIIStatsClear);
EXPORT_SYMBOL(ixEthAccDataPlaneShow);
EXPORT_SYMBOL(ixEthAccMiiPhyScan);
EXPORT_SYMBOL(ixEthAccMiiPhyConfig);
EXPORT_SYMBOL(ixEthAccMiiPhyReset);
EXPORT_SYMBOL(ixEthAccMiiLinkStatus);
EXPORT_SYMBOL(ixEthAccMiiShow);
EXPORT_SYMBOL(ixEthAccMiiStatsShow);

extern const char* mac2string(const unsigned char *mac);
extern UINT32 ixEthDBAddressCompare(UINT8 *mac1, UINT8 *mac2);
extern UINT32 ixEthAccMacBase[];

EXPORT_SYMBOL(mac2string);
EXPORT_SYMBOL(ixEthDBAddressCompare);              
EXPORT_SYMBOL(ixEthAccMacBase);
#endif /* __linux */
