/*
 * -- Intel Copyright Notice --
 * INTEL CONFIDENTIAL
 *
 * Copyright 2002 Intel Corporation All Rights Reserved.
 *
 * The source code contained or described herein and all documents
 * related to the source code ("Material") are owned by Intel Corporation
 * or its suppliers or licensors.  Title to the Material remains with
 * Intel Corporation or its suppliers and licensors.  The Material
 * contains trade secrets and proprietary and confidential information of
 * Intel or its suppliers and licensors.  The Material is protected by
 * worldwide copyright and trade secret laws and treaty provisions. No
 * part of the Material may be used, copied, reproduced, modified,
 * published, uploaded, posted, transmitted, distributed, or disclosed in
 * any way without Intel's prior express written permission.
 *
 * No license under any patent, copyright, trade secret or other
 * intellectual property right is granted to or conferred upon you by
 * disclosure or delivery of the Materials, either expressly, by
 * implication, inducement, estoppel or otherwise.  Any license under
 * such intellectual property rights must be express and approved by
 * Intel in writing.
 *
 * For further details, please see the file README.TXT distributed with
 * this software.
 * -- End Intel Copyright Notice --
*/
#ifndef _LINUX_CSR_IXP425_H_
#define _LINUX_CSR_IXP425_H_

#include <asm/hardware.h>
#include <asm/arch/irqs.h>

#define IXP425_UART1_BASE	IXP425_UART1_BASE_VIRT
#define IXP425_UART2_BASE	IXP425_UART2_BASE_VIRT

#define IXP425_EthA_BASE	IXP425_EthA_BASE_VIRT
#define IXP425_EthB_BASE	IXP425_EthB_BASE_VIRT

#define IXP425_PSMA_BASE	IXP425_NPEA_BASE_VIRT
#define IXP425_PSMB_BASE	IXP425_NPEB_BASE_VIRT
#define IXP425_PSMC_BASE	IXP425_NPEC_BASE_VIRT

#define IXP425_PERIPHERAL_BASE	IXP425_PERIPHERAL_BASE_VIRT

#define IXP425_QMGR_BASE	IXP425_QMGR_BASE_VIRT
#define IXP425_OSTS_BASE	IXP425_TIMER_BASE_VIRT

#define INT_VEC_PSMA		IRQ_IXP425_NPEA
#define INT_VEC_PSMB		IRQ_IXP425_NPEB
#define INT_VEC_PSMC		IRQ_IXP425_NPEC

#define IXP425_INT_LVL_QM1	IRQ_IXP425_QM1
#define IXP425_INT_LVL_QM2	IRQ_IXP425_QM2
#define IXP425_INT_LVL_USB	IRQ_IXP425_USB

#define IXP425_USB_BASE		IXP425_USB_BASE_VIRT

#define IXP425_EXPANSION_BUS_BASE1	IXP425_EXP_BUS_BASE_VIRT
#define IXP425_EXPANSION_BUS_BASE2	IXP425_EXP_BUS_BASE_VIRT
#define IXP425_EXPANSION_BUS_CS1_BASE	IXP425_EXP_BUS_CS1_BASE_VIRT

#define IXP425_EXP_CONFIG_BASE		IXP425_EXP_CFG_BASE_VIRT

#define IXP425_OSST_TICKS_PER_SECOND	60

#endif
