# -- Intel Copyright Notice --
# INTEL CONFIDENTIAL
#
# Copyright 2002 Intel Corporation All Rights Reserved.
#
# The source code contained or described herein and all documents
# related to the source code ("Material") are owned by Intel Corporation
# or its suppliers or licensors.  Title to the Material remains with
# Intel Corporation or its suppliers and licensors.  The Material
# contains trade secrets and proprietary and confidential information of
# Intel or its suppliers and licensors.  The Material is protected by
# worldwide copyright and trade secret laws and treaty provisions. No
# part of the Material may be used, copied, reproduced, modified,
# published, uploaded, posted, transmitted, distributed, or disclosed in
# any way without Intel's prior express written permission.
#
# No license under any patent, copyright, trade secret or other
# intellectual property right is granted to or conferred upon you by
# disclosure or delivery of the Materials, either expressly, by
# implication, inducement, estoppel or otherwise.  Any license under
# such intellectual property rights must be express and approved by
# Intel in writing.
#
# For further details, please see the file README.TXT distributed with
# this software.
# -- End Intel Copyright Notice --
DIRS := net netinet
VX_LINKS := intLib.h iv.h logLib.h lstLib.h netBufLib.h taskLib.h vxWorks.h \
            inetLib.h ioLib.h ipProto.h sysLib.h timers.h tickLib.h semLib.h
	    
VX_NET_LINKS := net/mbuf.h

IXP_LINKS := ixp425IntrCtl.h

STD_LINKS := assert.h stdio.h stdlib.h string.h unistd.h limits.h time.h

STD_INET_LINKS := netinet/if_ether.h netinet/in.h netinet/ip.h

archconfig: $(DIRS) $(VX_LINKS) $(VX_NET_LINKS) $(IXP_LINKS) $(STD_LINKS) \
	    $(STD_INET_LINKS)
	
distclean:
	rm -rf $(VX_LINKS) $(IXP_LINKS) $(STD_LINKS) $(DIRS)

$(DIRS):
	mkdir -p $@
	
$(STD_LINKS):
	ln -sfn std.h $@

$(STD_INET_LINKS):
	ln -sfn ../std.h $@

$(VX_LINKS):
	ln -sfn vx.h $@

$(VX_NET_LINKS):
	ln -sfn ../vx.h $@

$(IXP_LINKS):
	ln -sfn ixp425.h $@

