/*
 * -- Intel Copyright Notice --
 * INTEL CONFIDENTIAL
 *
 * Copyright 2002 Intel Corporation All Rights Reserved.
 *
 * The source code contained or described herein and all documents
 * related to the source code ("Material") are owned by Intel Corporation
 * or its suppliers or licensors.  Title to the Material remains with
 * Intel Corporation or its suppliers and licensors.  The Material
 * contains trade secrets and proprietary and confidential information of
 * Intel or its suppliers and licensors.  The Material is protected by
 * worldwide copyright and trade secret laws and treaty provisions. No
 * part of the Material may be used, copied, reproduced, modified,
 * published, uploaded, posted, transmitted, distributed, or disclosed in
 * any way without Intel's prior express written permission.
 *
 * No license under any patent, copyright, trade secret or other
 * intellectual property right is granted to or conferred upon you by
 * disclosure or delivery of the Materials, either expressly, by
 * implication, inducement, estoppel or otherwise.  Any license under
 * such intellectual property rights must be express and approved by
 * Intel in writing.
 *
 * For further details, please see the file README.TXT distributed with
 * this software.
 * -- End Intel Copyright Notice --
*/
#ifndef _STD_H_
#define _STD_H_

#include <linux/slab.h>
#include <linux/kernel.h>
#include <asm/semaphore.h>

#include <linux/in.h>
#include <linux/ip.h>
#include <linux/if_ether.h>

#define ETHERTYPE_PUP		ETH_P_PUP
#define ETHERTYPE_IP		ETH_P_IP
#define ETHERTYPE_ARP		ETH_P_ARP
#define ETHERTYPE_REVARP	ETH_P_RARP

#define ether_header		ethhdr
#define ether_dhost		h_dest
#define ether_shost		h_source
#define ether_type		h_proto

struct ip {
#if defined(__LITTLE_ENDIAN_BITFIELD)
	__u8	ip_hl:4,
		ip_v:4;
#elif defined (__BIG_ENDIAN_BITFIELD)
	__u8	ip_v:4,
  		ip_hl:4;
#else
#error	"Please fix <asm/byteorder.h>"
#endif
	__u8	ip_tos;
	__u16	ip_len;
	__u16	ip_id;
	__u16	ip_off;
	__u8	ip_ttl;
	__u8	ip_p;
	__u16	ip_sum;
	struct in_addr ip_src, ip_dst;
};

#define INET_ADDR_LEN		18

#define printf printk
#define malloc(size) kmalloc(size, GFP_ATOMIC)
#define free kfree

/* TODO */
#define rand()		net_random()
/* TODO */
#define srand(x)	net_srandom(x)


#define CODLETS_GETCHAR_ESC 27
extern struct semaphore __codlet_getchar;
static __inline__ int getchar(void)
{
    down(&__codlet_getchar);
    return CODLETS_GETCHAR_ESC;
}

/* XXX for IxUART.h */
#undef CLOCAL
#undef CREAD 
#undef CSIZE 
#undef CS5   
#undef CS6   
#undef CS7   
#undef CS8   
#undef STOPB 
#undef PARENB
#undef PARODD

/* assert macro. TODO - all uses of this should be changed to IxAssert */
#define assert(E) if (!(E)) { printk("Assertion '%s' failed.\n",#E); }

#endif
