
# @file component.mk
#
# @date 2-Jun-2003
#
# @brief  ADSL Driver Component Makefile
#
#
# Design Notes:  this Adsl Driver only Supports Utopia Level 1
#
# -- Intel Copyright Notice --
# 
# Copyright 2000-2003 Intel Corporation All Rights Reserved.
# 
# The source code contained or described herein and all documents
# related to the source code ("Material") are owned by Intel Corporation
# or its suppliers or licensors.  Title to the Material remains with
# Intel Corporation or its suppliers and licensors.
# 
# The Material is protected by worldwide copyright and trade secret laws
# and treaty provisions. No part of the Material may be used, copied,
# reproduced, modified, published, uploaded, posted, transmitted,
# distributed, or disclosed in any way except in accordance with the
# applicable license agreement .
# 
# No license under any patent, copyright, trade secret or other
# intellectual property right is granted to or conferred upon you by
# disclosure or delivery of the Materials, either expressly, by
# implication, inducement, estoppel, except in accordance with the
# applicable license agreement.
# 
# Unless otherwise agreed by Intel in writing, you may not remove or
# alter this notice or any other notice embedded in Materials by Intel
# or Intel's suppliers or licensors in any way.
# 
# For further details, please see the file README.TXT distributed with
# this software.
# 
# -- End Intel Copyright Notice --


TGT_DIR = $(WIND_BASE)/target


# IxASW_R3_9_22 is 20150 CPE modem application code revision R3_9_22
# IxASW_init_3_9_22 is 20150 CPE modem boot code revision 3_9_22
# IxASW_R13_9_22 is 20170 CPE modem application code revision R13_9_22
# IxASW_init_13_9_22 is 20170 CPE modem boot code revision 3_8_124
# IxASW_init_3_8_124.o is CO modem application code revision 3_8_124
# IxASW_C3_8_121.o is CO modem boot code revision C3_8_121
adsl_OBJ := \
	IxAdsl.o \
        IxAdslUtil.o \
	IxAdslCtrleLib.o

ifeq ($(IX_TARGET_OS),linux)
adsl_OBJ += IxAdslSymbols.o
adsl_EXPORT_OBJ := IxAdslSymbols.o
endif
adsl_CFLAGS += -DIX_USE_ADSL_CPE=1

ifeq ($(BSP), coyote)
adsl_CFLAGS += -DCONFIG_ARCH_IXP425_COYOTE=1
adsl_CFLAGS += -DIX_USE_ADSL_20170=1
adsl_OBJ += \
        IxASW_R13_9_22.o \
        IxASW_init_13_9_22.o
else
adsl_CFLAGS += -DCONFIG_ARCH_IXDP425=1
adsl_CFLAGS += -DIX_USE_ADSL_20150=1
adsl_OBJ += \
        IxASW_R3_9_22.o \
        IxASW_init_3_9_22.o
endif

