/**
 * @file IxCryptoAccCodeletSymbols.c
 *
 * @date 23-Apr-2003
 *
 * @brief This file declares exported symbols for linux kernel module builds.
 *
 * -- Intel Copyright Notice --
 * 
 * @par
 * Copyright 2002-2003 Intel Corporation All Rights Reserved.
 * 
 * @par
 * The source code contained or described herein and all documents
 * related to the source code ("Material") are owned by Intel Corporation
 * or its suppliers or licensors.  Title to the Material remains with
 * Intel Corporation or its suppliers and licensors.
 * 
 * @par
 * The Material is protected by worldwide copyright and trade secret laws
 * and treaty provisions. No part of the Material may be used, copied,
 * reproduced, modified, published, uploaded, posted, transmitted,
 * distributed, or disclosed in any way except in accordance with the
 * applicable license agreement .
 * 
 * @par
 * No license under any patent, copyright, trade secret or other
 * intellectual property right is granted to or conferred upon you by
 * disclosure or delivery of the Materials, either expressly, by
 * implication, inducement, estoppel, except in accordance with the
 * applicable license agreement.
 * 
 * @par
 * Unless otherwise agreed by Intel in writing, you may not remove or
 * alter this notice or any other notice embedded in Materials by Intel
 * or Intel's suppliers or licensors in any way.
 * 
 * @par
 * For further details, please see the file README.TXT distributed with
 * this software.
 * 
 * @par
 * -- End Intel Copyright Notice --
 */

#ifdef __linux

#include <linux/config.h>
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/sched.h>
#include <asm/semaphore.h>

#include "IxTypes.h"
#include "IxCryptoAccCodelet.h"

/* EXPORT_SYMBOL(ixCryptoAccCodeletMain);  */

UINT32 operationType;
UINT32 packetLen;


MODULE_PARM(operationType, "i");
MODULE_PARM_DESC(operationType,
         "1: Encrypt/decrypt operation\n"
         "2: Authentication operation\n"
         "3: Encrypt/decrypt and authentication operation\n");

MODULE_PARM(packetLen, "i");
MODULE_PARM_DESC(packetLen,
         "Packet length ranges from 64 bytes to 65456 bytes, if cipher\n"
         "algorithm is DES/3DES, packet length must be multiple of 8-byte\n"
         "(cipher block length); while AES algorithm must have packet length\n"
         "that is multiple of 16-bytecin size.\n");
         

static int __init CryptoInitModule(void)
{
    printk("Loading CryptoAcc Codelet...\n");
#if 0
    if (IX_SUCCESS != ixCryptoAccCodeletMain (3 /*operationType*/, 64
/*packetLen*/))
        return -1;
    else
        return 0;
#else
	ixCryptoAccJackInit();
#endif
}

static void __exit CryptoExitModule(void)
{
    printk("Unloading CryptoAcc Codelet\n");
}

module_init(CryptoInitModule);
module_exit(CryptoExitModule);


#endif
