/***
 * @file IxFpathConfigControl_p.h
 *
 * @author Intel Corporation
 * @date 15 April 2002
 *
 * @brief
 *
 *
 *
 * -- Intel Copyright Notice --
 * 
 * @par
 * Copyright 2002 Intel Corporation All Rights Reserved.
 * 
 * @par
 * The source code contained or described herein and all documents
 * related to the source code ("Material") are owned by Intel Corporation
 * or its suppliers or licensors.  Title to the Material remains with
 * Intel Corporation or its suppliers and licensors.
 * 
 * @par
 * The Material is protected by worldwide copyright and trade secret laws
 * and treaty provisions. No part of the Material may be used, copied,
 * reproduced, modified, published, uploaded, posted, transmitted,
 * distributed, or disclosed in any way except in accordance with the
 * applicable license agreement .
 * 
 * @par
 * No license under any patent, copyright, trade secret or other
 * intellectual property right is granted to or conferred upon you by
 * disclosure or delivery of the Materials, either expressly, by
 * implication, inducement, estoppel, except in accordance with the
 * applicable license agreement.
 * 
 * @par
 * Unless otherwise agreed by Intel in writing, you may not remove or
 * alter this notice or any other notice embedded in Materials by Intel
 * or Intel's suppliers or licensors in any way.
 * 
 * @par
 * For further details, please see the file README.TXT distributed with
 * this software.
 * 
 * @par
 * -- End Intel Copyright Notice --
 */

#ifndef IXFPATHCONFIGCONTROL_P_H
#define IXFPATHCONFIGCONTROL_P_H

#include "IxTypes.h"
#include "IxAtmTypes.h"
#include "IxFpathAcc.h"


IX_STATUS
ixFpathCfgCtrlInit( void );

IX_STATUS
ixFpathCfgCtrlTemplatePairSet(IxAtmNpeRxVcId npeVcId,
                              unsigned char *classifierTemplate,
                              int classifierTemplateLength,
                              unsigned char *modifierTemplate,
                              int modifierTemplateLength );

IX_STATUS
ixFpathCfgCtrlTemplatePairClear(IxAtmNpeRxVcId npeVcId);

IX_STATUS
ixFpathCfgCtrlEtherTypeSet(IxFpathEthernetPort port,
                           UINT16 etherType );

IX_STATUS
ixFpathCfgCtrlWanMacAddrCallbackSet(IxFpathAccNewWanMacAddrCallback macAddrCallback,
                                       IxAtmNpeRxVcId npeVcId,
                                       IxFpathAccClientId clientId);


IX_STATUS ixFpathCfgCtrlStatisticsGet(
    IxAtmNpeRxVcId npeVcId,
    int *packetCnt);


void
ixFpathCfgCtrlShow( void );

#endif /* IXFPATHCONFIGCONTROL_P_H */


