/*
 * -- Intel Copyright Notice --
 * 
 * Copyright 2002-2003 Intel Corporation All Rights Reserved.
 * 
 * The source code contained or described herein and all documents
 * related to the source code ("Material") are owned by Intel Corporation
 * or its suppliers or licensors.  Title to the Material remains with
 * Intel Corporation or its suppliers and licensors.
 * 
 * The Material is protected by worldwide copyright and trade secret laws
 * and treaty provisions. No part of the Material may be used, copied,
 * reproduced, modified, published, uploaded, posted, transmitted,
 * distributed, or disclosed in any way except in accordance with the
 * applicable license agreement .
 * 
 * No license under any patent, copyright, trade secret or other
 * intellectual property right is granted to or conferred upon you by
 * disclosure or delivery of the Materials, either expressly, by
 * implication, inducement, estoppel, except in accordance with the
 * applicable license agreement.
 * 
 * Unless otherwise agreed by Intel in writing, you may not remove or
 * alter this notice or any other notice embedded in Materials by Intel
 * or Intel's suppliers or licensors in any way.
 * 
 * For further details, please see the file README.TXT distributed with
 * this software.
 * 
 * -- End Intel Copyright Notice --
*/
#include <linux/config.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/init.h>

#include "std.h"

/* VxWorks wrapers */
#include <vx.h>
EXPORT_SYMBOL(taskSpawn);
EXPORT_SYMBOL(taskDelete);
EXPORT_SYMBOL(taskIdSelf);
EXPORT_SYMBOL(taskDelay);
EXPORT_SYMBOL(taskPrioritySet);
EXPORT_SYMBOL(sysClkRateGet);
EXPORT_SYMBOL(clock_gettime);
EXPORT_SYMBOL(tickGet);
EXPORT_SYMBOL(semGive);
EXPORT_SYMBOL(semTake);

/* Net Pool */
#include <simple_pool.h>
EXPORT_SYMBOL(simple_pool_init);
EXPORT_SYMBOL(simple_pool_get);
EXPORT_SYMBOL(simple_pool_put);

static int __init csr_init_module(void)
{
    /* Add initialization code here */
#ifdef DEBUG
    printk("\n\n"__FUNCTION__": addr=%p\n\n", csr_init_module);
#endif
    printk("Module init.\n");
    return 0;
}

static void __init csr_cleanup_module(void)
{
    /* Add cleanup code here */
    printk("Module uninit.\n.");
}

module_init(csr_init_module);
module_exit(csr_cleanup_module);

