/**
 * @file    IxTimersCodeletMain.h
 *
 * @date    1-Apr-2003
 *
 * @brief   Header file for the IXP425 timers demo
 *
 * -- Intel Copyright Notice --
 * 
 * @par
 * Copyright 2002-2003 Intel Corporation All Rights Reserved.
 * 
 * @par
 * The source code contained or described herein and all documents
 * related to the source code ("Material") are owned by Intel Corporation
 * or its suppliers or licensors.  Title to the Material remains with
 * Intel Corporation or its suppliers and licensors.
 * 
 * @par
 * The Material is protected by worldwide copyright and trade secret laws
 * and treaty provisions. No part of the Material may be used, copied,
 * reproduced, modified, published, uploaded, posted, transmitted,
 * distributed, or disclosed in any way except in accordance with the
 * applicable license agreement .
 * 
 * @par
 * No license under any patent, copyright, trade secret or other
 * intellectual property right is granted to or conferred upon you by
 * disclosure or delivery of the Materials, either expressly, by
 * implication, inducement, estoppel, except in accordance with the
 * applicable license agreement.
 * 
 * @par
 * Unless otherwise agreed by Intel in writing, you may not remove or
 * alter this notice or any other notice embedded in Materials by Intel
 * or Intel's suppliers or licensors in any way.
 * 
 * @par
 * For further details, please see the file README.TXT distributed with
 * this software.
 * 
 * @par
 * -- End Intel Copyright Notice --
 *
 * 
 *
 */


#ifndef IXTIMERSCODELETMAIN_H_
#define IXTIMERSCODELETMAIN_H_

#include "IxTypes.h"

UINT32 ixTimersPmuTickGet(void);
void ixTimersIsrShow(void);
PUBLIC void ixTimersCodeletEstimatesShow(void);
PUBLIC void ixTimersCodeletResultsShow(void);
void ixTimersCodeletTimer1Isr(void *arg);
void ixTimersCodeletTimer2Isr(void *arg);
void ixTimersCodeletTsIsr(void *arg);
void ixTimersCodeletWdogIsr(void *arg);
void ixTimersCodeletPmuIsr(void *arg);
PUBLIC void ixTimersCodeletUnload(void);
PUBLIC IX_STATUS ixTimersCodeletMain(void);


#endif /* IXTIMERSCODELETMAIN_H_ */
