/***
 * @file IxFpathNpeInterface_p.h
 *
 * @author Intel Corporation
 * @date 15 April 2002
 *
 * @brief  provides a fast path specific interface to IxNpeMh
 *
 *
 *
 * -- Intel Copyright Notice --
 * 
 * @par
 * Copyright 2002 Intel Corporation All Rights Reserved.
 * 
 * @par
 * The source code contained or described herein and all documents
 * related to the source code ("Material") are owned by Intel Corporation
 * or its suppliers or licensors.  Title to the Material remains with
 * Intel Corporation or its suppliers and licensors.
 * 
 * @par
 * The Material is protected by worldwide copyright and trade secret laws
 * and treaty provisions. No part of the Material may be used, copied,
 * reproduced, modified, published, uploaded, posted, transmitted,
 * distributed, or disclosed in any way except in accordance with the
 * applicable license agreement .
 * 
 * @par
 * No license under any patent, copyright, trade secret or other
 * intellectual property right is granted to or conferred upon you by
 * disclosure or delivery of the Materials, either expressly, by
 * implication, inducement, estoppel, except in accordance with the
 * applicable license agreement.
 * 
 * @par
 * Unless otherwise agreed by Intel in writing, you may not remove or
 * alter this notice or any other notice embedded in Materials by Intel
 * or Intel's suppliers or licensors in any way.
 * 
 * @par
 * For further details, please see the file README.TXT distributed with
 * this software.
 * 
 * @par
 * -- End Intel Copyright Notice --
 */

#ifndef IXFPATHNPEINTERFACE_P_H
#define IXFPATHNPEINTERFACE_P_H

#include "IxTypes.h"
#include "IxNpeMh.h"
#include "IxAtmTypes.h"
#include "IxFpathAcc.h"


typedef unsigned int IxFpathIndex;

typedef void (*IxFpathNpeIfWanMacMsgCallback ) (IxFpathIndex, unsigned char *);

IX_STATUS
ixFpathNpeIfInit( void );

IX_STATUS
ixFpathNpeIfDisableSend( IxNpeMhNpeId npeId,
                         IxFpathIndex fpathIndex,
                         IxAtmNpeRxVcId npeVcid );

IX_STATUS
ixFpathNpeIfEnableSend( IxNpeMhNpeId npeId,
                        IxFpathIndex fpathIndex,
                        IxAtmNpeRxVcId npeVcid );

IX_STATUS
ixFpathNpeIfModifierDownload( IxNpeMhNpeId npeId,
                              IxFpathIndex fpathIndex,
                              unsigned char *template,
                              int templateLength );

IX_STATUS
ixFpathNpeIfClassifierDownload( IxNpeMhNpeId npeId,
                                IxFpathIndex fpathIndex,
                                unsigned char *template,
                                int templateLength );

IX_STATUS
ixFpathNpeIfWanMacCallbackRegister(IxFpathNpeIfWanMacMsgCallback callback);

IX_STATUS
ixFpathNpeIfStatisticsGet( IxNpeMhNpeId npeId,
                           IxFpathIndex fpathIndex,
                           int *packetCnt );

IX_STATUS
ixFpathNpeIfStatisticsClear( IxNpeMhNpeId npeId,
                             IxFpathIndex fpathIndex);

IX_STATUS
ixFpathNpeIfEtherTypeSend( IxNpeMhNpeId npeId,
                           UINT16 etherType );

void
ixFpathNpeIfShow( void );

#endif /* IXFPATHNPEINTERFACE_P_H */


