#ifndef _IP_CONNTRACK_MSN_H
#define _IP_CONNTRACK_MSN_H

#ifndef __KERNEL__
#error Only in kernel.
#endif

/* Protects MSN related data */
DECLARE_LOCK_EXTERN(ip_msn_lock);

/* Default MSN port */
#define IP_CT_IS_MSN	1863
#define IP_CT_MSN_RX	7001

enum msn_type {
	IP_CT_NONE,
	IP_CT_FILE_TRANS,
	IP_CT_VOICE_SESSION_INIT,
	IP_CT_VOICE_TRANS,
	IP_CT_VIDEO_SESSION
} ;

/* This structure is per expected connection */
struct ip_ct_msn_expect {
	u_int16_t port;
	enum ip_conntrack_dir dir;
	unsigned int len;
};

/* This structure exists only once per master */
struct ip_ct_msn_master {
	int is_msn;				/* MSN connection */
#ifdef CONFIG_IP_NF_NAT_NEEDED
	enum ip_conntrack_dir dir;		/* Direction of the original connection */
	u_int32_t seq[IP_CT_DIR_MAX];		/* Exceptional packet mangling for signal addressess... */
	unsigned int offset[IP_CT_DIR_MAX];	/* ...and the offset of the addresses in the payload */
#endif
};

#endif /* _IP_CONNTRACK_MSN_H */
