#ifndef _IPT_DRELAY_H
#define _IPT_DRELAY_H

#define DNS_MAX_LEN 256
#define	DNS_PORT	53
#define DNS_NAME_SIZE 255

union header_flags {
	u_int16_t flags;

	struct {
		unsigned short int rcode:4;
		unsigned short int unused:3;
		unsigned short int recursion_avail:1;
		unsigned short int want_recursion:1;
		unsigned short int truncated:1;
		unsigned short int authorative:1;
		unsigned short int opcode:4;
		unsigned short int question:1;
	} f;
};

struct dns_header_s {
	u_int16_t id;
	union header_flags flags;
	u_int16_t qdcount;
	u_int16_t ancount;
	u_int16_t nscount;
	u_int16_t arcount;
};

struct dns_rr {
	char name[DNS_NAME_SIZE];
	u_int16_t type;
	u_int16_t class;
};

struct dns_message {
	struct dns_header_s header;
	struct dns_rr question;
};

struct ipt_drelay_info {
	char string[DNS_MAX_LEN];
	u_int16_t invert;
	u_int16_t len;
};

/* TYPE values */
enum
{ A = 1,      /* a host address */
  NS,         /* an authoritative name server */
  MD,       /* a mail destination (Obsolete - use MX) */
  MF,       /* */
  CNAME,    /* the canonical name for an alias */
  SOA,      /* marks the start of a zone of authority  */
  MB,       /* a mailbox domain name (EXPERIMENTAL) */
  MG,       /* */
  MR,       /* */
  NUL,      /* */
  WKS,      /* a well known service description */
  PTR,      /* a domain name pointer */
  HINFO,    /* host information */
  MINFO,    /* mailbox or mail list information */
  MX,       /* mail exchange */
  TXT,      /* text strings */
  AAA = 0x1c /* IPv6 A */
};

#endif /* _IPT_DRELAY_H */
