#ifndef _IPT_SIPRATE_H
#define _IPT_SIPRATE_H

/* timings are in milliseconds. */
#define SIP_IPT_LIMIT_SCALE 10000

#define SIP_LIST_SIZE       0x100
#define SIP_HASH_MAX        0x10
#define SIP_HASH_LOG	    9
#define SIP_HASH_SIZE	    (1 << SIP_HASH_LOG)

struct sip_host {
        struct sip_host *next;
        struct in_addr src_addr;
        unsigned long prev;
        u_int32_t credit;
        u_int32_t credit_cap, cost;
};

struct limitstate {
        struct sip_host list[SIP_LIST_SIZE]; 
        struct sip_host *hash[SIP_HASH_SIZE];
        int index;		
};

struct dropsip {
	struct dropsip *next;
        struct in_addr src_addr;
        u_int32_t next_time;
};

struct droplist {
        struct dropsip list[SIP_LIST_SIZE]; 
        struct dropsip *hash[SIP_HASH_SIZE];
        int index;		
};

/* 1/10,000 sec period => max of 10,000/sec.  Min rate is then 429490
   seconds, or one every 59 hours. */
struct ipt_siprateinfo {
	u_int32_t avg;    /* Average secs between packets * scale */
	u_int32_t burst;  /* Period multiplier for upper limit. */
/* 2003/4/30 Steve ++ */
	u_int32_t timeout;
	int delay;
	u_int32_t next;
/* Steve -- */

	/* Used internally by the kernel */
	unsigned long prev;
	u_int32_t credit;
	u_int32_t credit_cap, cost;
	struct limitstate *state;

	struct droplist *drop;

	/* Ugly, ugly fucker. */
	struct ipt_siprateinfo *master;
};
#endif /*_IPT_SIPRATE_H*/
