#ifndef _IPT_SYNRATE_H
#define _IPT_SYNRATE_H

/* timings are in milliseconds. */
#define IPT_SYNLIMIT_SCALE 10000

#define SIPSYN_LIST_SIZE       0x1800
#define SIPSYN_HASH_MAX        0x100
#define SIPSYN_HASH_LOG        9
#define SIPSYN_HASH_SIZE       (1 << SIPSYN_HASH_LOG)
#define SIPSYN_PAGES           5

struct sipsyn_list {
	struct sipsyn_list *next;
	struct in_addr src_addr;
	unsigned short sport;
	unsigned long seq;
	u_int32_t last_seen;
};

struct synlimit {
	struct sipsyn_list list[SIPSYN_LIST_SIZE];
	struct sipsyn_list *hash[SIPSYN_HASH_SIZE];
	int index;
};

/* 1/10,000 sec period => max of 10,000/sec.  Min rate is then 429490
   seconds, or one every 59 hours. */
struct ipt_synrateinfo {
	u_int32_t avg;    /* Average secs between packets * scale */
	u_int32_t burst;  /* Period multiplier for upper limit. */

	/* Used internally by the kernel */
	unsigned long prev;
	u_int32_t credit;
	u_int32_t credit_cap, cost;
	u_int32_t timeout;

	struct synlimit *limit;

	/* Ugly, ugly fucker. */
	struct ipt_synrateinfo *master;
};
#endif /*_IPT_SYNRATE_H*/
