
/////////////////////
/* Jack ++ 2004/01/09 */
#ifdef CONFIG_IPSEC_NAT_TRAVERSAL
        uint8_t natt_type = req->natt_type;
	uint8_t natt_head = req->natt_head;
        uint16_t natt_sport = req->natt_sport;
	uint16_t natt_dport = req->natt_dport; 
	int iphlen = 0;

		 {
			struct sk_buff* tskb = skb;

			tskb = skb_copy_expand(skb,
					       skb_headroom(skb),
					       skb_tailroom(skb) + natt_head,
					       GFP_ATOMIC);
#ifdef NET_21
			if(tskb && skb->sk) {
				skb_set_owner_w(tskb, skb->sk);
			}
#endif /* NET_21 */
			skb = tskb;
			if (!skb) {
				stats->tx_errors++;
				goto cleanup;
			}
			KLIPS_PRINT(debug_tunnel & DB_TN_CROUT,
				    "klips_debug:ipsec_tunnel_start_xmit: "
				    "head,tailroom: %d,%d after allocation\n",
				    skb_headroom(skb), skb_tailroom(skb));
		}

	if (natt_type && natt_head) {
		struct iphdr *ipp = skb->nh.iph;
		struct udphdr *udp;
		KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
			"klips_debug:ipsec_tunnel_start_xmit: "
			"encapsuling packet into UDP (NAT-Traversal)\n");
		iphlen = ipp->ihl << 2;
		ipp->tot_len =
			htons(ntohs(ipp->tot_len) + natt_head);
		if(skb_tailroom(skb) < natt_head) {
			printk(KERN_WARNING "klips_error:ipsec_tunnel_start_xmit: "
				"tried to skb_put %d, %d available. "
				"This should never happen, please report.\n",
				natt_head,
				skb_tailroom(skb));
			stats->tx_errors++;
			goto cleanup;
		}
		skb_put(skb, natt_head);
		udp = (struct udphdr *)((char *)ipp + iphlen);
		/* move ESP hdr after UDP hdr */

		memmove((void *)((char *)udp + natt_head),
			(void *)(udp),
			ntohs(ipp->tot_len) - iphlen - natt_head);
		/* clear UDP & Non-IKE Markers (if any) */
		memset(udp, 0, natt_head);
		/* fill UDP with usefull informations ;-) */
		udp->source = htons(natt_sport);
		udp->dest = htons(natt_dport);
		udp->len = htons(ntohs(ipp->tot_len) - iphlen);
		/* set protocol */
		ipp->protocol = IPPROTO_UDP;
		/* fix IP checksum */
		ipp->check = 0;
		ipp->check = ip_fast_csum((unsigned char *)ipp, ipp->ihl);
	}
#endif

/* Jack -- 2004/01/09 */
////////////////////
