#include <stdio.h>
#include "tinyproxy.h"

static int
use_clamdcheck(char *file_path, char *virus_name)
{
	int ret = 0, count = 0;
	char cmd[1024], buf[1024], found[128];
	FILE *fp;
    
	sprintf(cmd, "%s %s 2>&1", CLAM_COMMAND, file_path);
    
	if ((fp = popen(cmd, "r"))) {
		while ((fgets(buf, 1023, fp)) != NULL) {
			if (sscanf(buf, "%*s %s %s", virus_name, found) == 2) {
				if (strstr(found, "FOUND")) {
					ret = 1;
					break;
				}
			}
                        count++;
                        if (count > 20) {
                                ret = 0;
                                break;
                        }
		}	    
		pclose(fp);
	}    
    
	return ret;
}

static int 
use_sophoscheck(char *file_path, char *virus_name)
{
	int ret = 0, count = 0;
	char cmd[1024], buf[4096];
	FILE *fp;

	sprintf(cmd, "%s %s 2>&1", SOPHOS_COMMAND, file_path);

	if ((fp = popen(cmd, "r"))) {
		while ((fgets(buf, 4095, fp))) {
			if (!strncmp(buf, "FILE INFECTED:", 14)) {
				sscanf(buf, "%*s %*s %s",
				       virus_name);
				log_message(LOG_INFO, "use_sophoscheck().....virus %s!!", virus_name);
				ret = 1;
				break;
			}

                        count++;
                        if (count > 20) {
                                ret = 0;
                                break;
                        }
		}
		pclose(fp);
	}

	return ret;
}

int
check_virus(char *file_path, char *virus_name, unsigned int scanner)
{
	int ret = 0;

	if (scanner & VIRUS_SOPHOS)
		ret = use_sophoscheck(file_path, virus_name);

	if (ret)
		return ret;
	else if (scanner & VIRUS_CLAM)
		ret = use_clamdcheck(file_path, virus_name);

	return ret;
}
