#ifndef _IPT_VIRUS_H
#define _IPT_VIRUS_H

/* timings are in milliseconds. */
#define VIRUS_IPT_LIMIT_SCALE 10000

#define VIRUS_LIST_SIZE		0x80 /* 128 */
#define VIRUS_HASH_MAX		0x10 /* 16 */
#define VIRUS_HASH_LOG		5
#define VIRUS_HASH_SIZE		(1 << VIRUS_HASH_LOG) /* 32 */

#define VIRUS_RETRY_LIST_SIZE	0x2600
#define	VIRUS_RETRY_HASH_MAX	0x100 /* 256 */
#define	VIRUS_RETRY_HASH_LOG	9
#define	VIRUS_RETRY_HASH_SIZE	(1 << VIRUS_RETRY_HASH_LOG) /* 512 */
#define	VIRUS_NAME		20

struct addrinfo {
	struct in_addr addr;
	unsigned short port;
};

struct packetinfo {
	u_int8_t    protocol;
	struct addrinfo saddr;
	struct addrinfo daddr;
	unsigned long seq;
};
	
struct virus_retry_list {
	struct virus_retry_list *next;
	struct packetinfo packetinfo;
	u_int32_t last_seen;
};

struct virusretry {
	int index;
	struct virus_retry_list list[VIRUS_RETRY_LIST_SIZE];
	struct virus_retry_list *hash[VIRUS_RETRY_HASH_SIZE];
};

struct virus_host {
	struct virus_host *next;
	struct in_addr src_addr;
	unsigned long prev;
	u_int32_t credit;
	u_int32_t credit_cap, cost;
};

struct virusstate {
	struct virus_host list[VIRUS_LIST_SIZE]; 
	struct virus_host *hash[VIRUS_HASH_SIZE];
	int index;
};

struct virusdropsip {
	struct virusdropsip *next;
	struct in_addr src_addr;
	unsigned long droptime;
	unsigned long timeout;
	unsigned int id;
	u_int16_t alert;
};

struct virusdroplist {
	struct virusdropsip list[VIRUS_LIST_SIZE]; 
	struct virusdropsip *hash[VIRUS_HASH_SIZE];
	int index;		
};

struct ipt_virusrateinfo {
	u_int32_t avg;    /* Average secs between packets * scale */
	u_int32_t burst;  /* Period multiplier for upper limit. */
	u_int32_t next;

	/* Used internally by the kernel */
	unsigned long prev;
	u_int32_t credit;
	u_int32_t credit_cap, cost;
	struct virusstate *state;

	struct virusdroplist *drop;

	struct virusretry *virusretry;

	char name[VIRUS_NAME];
	unsigned int id;
	struct proc_dir_entry *status_proc;

	/* Ugly, ugly fucker. */
	struct ipt_virusrateinfo *master;
};

#endif /*_IPT_VIRUSRATE_H*/
